EnableExplicit

CompilerIf Defined(PrinterLib_Include,#PB_Constant)
  XIncludeFile "Printer_Lib_Res.pb"
CompilerEndIf

CompilerIf #PB_Compiler_Version<430
  Structure i
    i.long
  EndStructure
  #PB_Word=#Word
  #PB_Long=#Long
  Macro ListSize
    CountList
  EndMacro
  Macro pPrintSetupTemplateName
    lpPrintSetupTemplateName
  EndMacro
CompilerEndIf

CompilerIf #PB_Compiler_Version=430 Or #PB_Compiler_Version=431
  Macro pPrintSetupTemplateName
    lpSetupTemplateName
  EndMacro
CompilerEndIf

CompilerIf #PB_Compiler_Version>=440
  Macro pPrintSetupTemplateName
    lpSetupTemplateName
  EndMacro
CompilerEndIf

Global PrintLib_PN.s
Global PrintLib_DC.i
Global PrintLib_PH.i
Global PrintLibDLG.PRINTDLG
Global PrintLibDLGEX.PRINTDLG
Global PrintLib_pPageRanges.l
Global PrintLib_Pen.l
Global PrintLib_Font
Global PrintLib_FontName$
Global PrintLib_FontHeight.l
Global PrintLib_FontFlags.l
Global PrintLib_FontRotate.l
Global PrintLib_Brush.l
Global PrintLib_Brushcolor.l
Global PrintLib_Align.l
Global PrintLib_BKMode.l
Global PrintLib_Linewidth.f
Global PrintLib_Linecolor.l
Global PrintLib_Linestyle.l
Global PrintLib_Units.l
Global PrintLib_oldDC.l
Global PrintLib_Preview.l
Global PrintLib_PreviewX.l
Global PrintLib_PreviewY.l
Global PrintLib_Debug.l
Global PrintLib_DebugFile.l
Global *PrintLibDEVMODE.DEVMODE
Global *PrintLibDEVMODESize

Declare.l ipprint_AdvancedProperties(Window.i)
Declare.l ipprint_AngleArc(x.f,y.f,r.f,Startangle.l,Sweepangle.l)
Declare.l ipprint_Arc(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f)
Declare.l ipprint_Chord(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l=#False)
Declare.f ipprint_ConvertPointsToUnitsX(x.l)
Declare.f ipprint_ConvertPointsToUnitsY(y.l)
Declare.l ipprint_ConvertUnitsToPointsX(x.f)
Declare.l ipprint_ConvertUnitsToPointsY(y.f)
Declare.l ipprint_CreateBrush(Color.l)
Declare.l ipprint_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
Declare.l ipprint_CreateHatchBrush(Style.l,Color.l)
Declare.l ipprint_CreatePatternBrush(hBMP.l)
Declare.l ipprint_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style)
Declare.f ipprint_DrawText(x.f,y.f,w.f,h.f,Text$,Format.l=0,*RX=0,*RY=0,*RW=0,*RH=0)
Declare.l ipprint_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l=#False)
Declare   ipprint_End()
Declare.l ipprint_EndDocPrinter()
Declare.l ipprint_EnumFontID(Index.l)
Declare.s ipprint_EnumFontName(Index.l)
Declare.l ipprint_EnumFonts(CharSet.l=#DEFAULT_CHARSET,PitchAndFamily.l=0,Name.s="")
Declare.s ipprint_EnumFontScript(Index.l)
Declare.l ipprint_EnumFontsExProc(*lpelfe.ENUMLOGFONTEX,*lpntme,FontType.l,lParam.l)
Declare.l ipprint_EnumFontsProc(*lpelfe,*lpntme,FontType.l,lParam.l)
Declare.s ipprint_EnumFontStyle(Index.l)
Declare.s ipprint_EnumPrinterName(Index.l)
Declare.l ipprint_EnumPrinters(enum.l=#PRINTER_ENUM_LOCAL|#PRINTER_ENUM_CONNECTIONS) ; Enumerates all Printers
Declare.l ipprint_FillRect(x1.f,y1.f,x2.f,y2.f)
Declare.l ipprint_Font(Font$,Height.l,Flags.l=0,Rotate.l=0)
Declare.l ipprint_FrameRect(x1.f,y1.f,x2.f,y2.f)
Declare   ipprint_GeneralDebugInfo()
Declare.l ipprint_GetArcDirection()
Declare.s ipprint_GetDefaultPrinter()
Declare.s ipprint_GetDeviceCapabilities(Type.l,Separator$="|")
Declare.l ipprint_GetDeviceCaps(Type.l)
Declare.s ipprint_GetLastError(err.l=0)
Declare.l ipprint_GetLineColor()
Declare.l ipprint_GetLineStyle()
Declare.f ipprint_GetLineWidth()
Declare.f ipprint_GetOutlineTextMetrics(Type.l)
Declare.l ipprint_GetPreviewImage(Index.l)
Declare.l ipprint_GetPrinter(Level.l,*pPrinter,cbBuf.l,pcbNeeded.l)
Declare.l ipprint_GetStatus(Type.l)
Declare.l ipprint_GetTextAlign()
Declare.f ipprint_GetTextMetrics(Type.l)
Declare.l ipprint_GetUnits()
Declare.f ipprint_GetX()
Declare.f ipprint_GetY()
Declare.l ipprint_GradientFill(*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
Declare.l ipprint_Image(Imagenr.l,x.f,y.f,w.f=0,h.f=0,Mode.l=#SRCCOPY)
Declare   ipprint_Init()
Declare.l ipprint_Line(x1.f,y1.f,x2.f,y2.f)
Declare.l ipprint_LineTo(x.f,y.f)
Declare.l ipprint_LoadDEVMODE(Filename$)
Declare.l ipprint_NewPage()
Declare.l ipprint_OpenPrinter(PrinterName$="",Option$="",Access.l=0)
Declare.l ipprint_Pie(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l=#False)
Declare.l ipprint_Plot(x.f,y.f)
Declare.l ipprint_PrintDlg(Window.i=0,PrinterName$="",Option1$="",Option2$="")
Declare.l ipprint_PrintPrefs(Window.i=0,PrinterName$="")
Declare.l ipprint_Properties(Window.i=0)
Declare.l ipprint_Rectangle(x1.f,y1.f,x2.f,y2.f,Fill.l=#False)
Declare.l ipprint_ResetDC(Option$)
Declare.l ipprint_RoundRect(x1.f,y1.f,x2.f,y2.f,w.f,h.f,Fill.l=#False)
Declare   ipprint_SaveDebugInfo(Info$)
Declare.l ipprint_SaveDEVMODE(Filename$)
Declare.l ipprint_SetArcDirection(arcd.l)
Declare.l ipprint_SetBkColor(Color.l)
Declare.l ipprint_SetBkMode(Mode.l)
Declare   ipprint_SetDebug(Mode.l)
Declare   ipprint_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
Declare.l ipprint_SetLineColor(Color.l)
Declare.l ipprint_SetLineStyle(Style.l)
Declare.l ipprint_SetLineWidth(w.f)
Declare.l ipprint_SetPRINTDLG(Option$,*PrinterParameters.PRINTDLG)
Declare   ipprint_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
Declare.l ipprint_SetPrinter(Level.l,*pPrinter,Command.l)
Declare.l ipprint_SetStatus(Status.l)
Declare.l ipprint_SetTextAlign(Mode.l)
Declare.l ipprint_SetTextJustification(l.f,Count.l)
Declare.f ipprint_SetTextSpacing(l.f)
Declare.l ipprint_SetUnits(Unit.l)
Declare.l ipprint_SetX(x.f)
Declare.l ipprint_SetXY(x.f,y.f)
Declare.l ipprint_SetY(y.f)
Declare   ipprint_Standardsettings()
Declare.l ipprint_StartDocPrinter(Jobname$,OutputFileName$="",Datatype$="RAW")
Declare.l ipprint_StartPreview(x.l)
Declare.l ipprint_StartPrinting(jobname$,outfile$)
Declare.l ipprint_StopPreview()
Declare.l ipprint_StopPrinting()
Declare.l ipprint_Text(x.f,y.f,Text$)
Declare.f ipprint_TextHeight(Text$)
Declare.f ipprint_TextWidth(Text$)
Declare.l ipprint_WriteData(*Membuffer,Size.l)
Declare.l ipprint_WriteString(String$,Mode=#PB_Ascii)

; Declare   Print_About()
; Declare.l Print_AdvancedProperties(Window.i)
; Declare.l Print_AngleArc(x.f,y.f,r.f,startangle.l,sweepangle.l)
; Declare.l Print_Arc(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f)
; Declare.l Print_Chord(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,fill.l)
; Declare.l Print_Circle(x.f,y.f,r.f,Fill.l)
; Declare.f Print_ConvertPointsToUnitsX(x.l)
; Declare.f Print_ConvertPointsToUnitsY(y.l)
; Declare.l Print_ConvertUnitsToPointsX(x.f)
; Declare.l Print_ConvertUnitsToPointsY(y.f)
; Declare.l Print_CountPrinters()
; Declare.l Print_CreateBrush(Color.l)
; Declare.l Print_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
; Declare.l Print_CreateHatchBrush(Style.l,Color.l)
; Declare.l Print_CreatePatternBrush(hBMP.l)
; Declare.l Print_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style.l)
; Declare.f Print_DrawText(x.f,y.f,w.f,h.f,Text$)
; Declare.f Print_DrawText2(x.f,y.f,w.f,h.f,Text$,Format.l)
; Declare.f Print_DrawText3(x.f,y.f,w.f,h.f,Text$,Format.l,*RX.l,*RY.l,*RW.l,*RH.l)
; Declare.l Print_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l)
; Declare   Print_End()
; Declare.l Print_EndDocPrinter()
; Declare.l Print_EndPagePrinter()
; Declare.l Print_EnumFontID(Index.l)
; Declare.s Print_EnumFontName(Index.l)
; Declare.l Print_EnumFonts()
; Declare.l Print_EnumFonts2(CharSet.b)
; Declare.l Print_EnumFonts3(CharSet.b,Name.s)
; Declare.s Print_EnumFontScript(Index.l)
; Declare.s Print_EnumFontStyle(Index.l)
; Declare.s Print_EnumPrinterName(Index.l)
; Declare.l Print_EnumPrinters()
; Declare.l Print_FillRect(x1.f,y1.f,x2.f,y2.f)
; Declare.l Print_Font(Font$,Height.l)
; Declare.l Print_Font2(Font$,Height.l,Flags.l)
; Declare.l Print_Font3(Font$,Height.l,Flags.l,Rotate.l)
; Declare.l Print_FrameRect(x1.f,y1.f,x2.f,y2.f)
; Declare.l Print_GetArcDirection()
; Declare.s Print_GetDefaultPrinter()
; Declare.s Print_GetDeviceCapabilities(Type.l)
; Declare.l Print_GetDeviceCaps(Type.l)
; Declare.l Print_GetFontFlags()
; Declare.l Print_GetFontHeight()
; Declare.s Print_GetFontName()
; Declare.l Print_GetFontRotate()
; Declare.s Print_GetLastError()
; Declare.l Print_GetLineColor()
; Declare.l Print_GetLineStyle()
; Declare.f Print_GetLineWidth()
; Declare.l Print_GetPreviewCount()
; Declare.l Print_GetPreviewImage(Index.l)
; Declare.l Print_GetPrinterHandle()
; Declare.s Print_GetPrinterName_UNICODE()
; Declare.l Print_GetStatus(Type.l)
; Declare.l Print_GetTextAlign()
; Declare.f Print_GetTextMetrics(Type.l)
; Declare.l Print_GetUnits()
; Declare.f Print_GetX()
; Declare.f Print_GetY()
; Declare.l Print_GradientFill(*Vertex.i,NumVertex.l,*Mesh.i,NumMesh.l,Mode.l)
; Declare.l Print_Image(ImageId.l,x.f,y.f)
; Declare.l Print_Image2(ImageId.l,x.f,y.f,w.f,h.f)
; Declare.l Print_Image3(ImageId.l,x.f,y.f,w.f,h.f,Mode.l)
; Declare   Print_Init()
; Declare.l Print_InvertRect(x1.f,y1.f,x2.f,y2.f)
; Declare.l Print_Line(x.f,y.f,w.f,h.f)
; Declare.l Print_LineTo(x.f,y.f)
; Declare.l Print_LoadDEVMODE(Filename$)
; Declare.l Print_SaveDEVMODE(Filename$)
; Declare.l Print_NewPage()
; Declare.l Print_OpenPrinter_UNICODE()
; Declare.l Print_OpenPrinter2_UNICODE(Printername$)
; Declare.l Print_OpenPrinter3_UNICODE(Printername$,Option$)
; Declare.l Print_OpenPrinter4_UNICODE(Printername$,Option$,Access.l)
; Declare.l Print_Pie(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,fill.l)
; Declare.l Print_PrintDlg(Window.i)
; Declare.l Print_PrintDlg2(Window.i,Printername$)
; Declare.l Print_PrintDlg3(Window.i,Printername$,Option$)
; Declare.l Print_PrintDlg4(Window.i,Printername$,Option1$,Option2$)
; Declare.l Print_PrintPrefs()
; Declare.l Print_PrintPrefs2(Window.i)
; Declare.l Print_PrintPrefs3(Window.i,PrinterName$)
; Declare.l Print_Properties(Window.i)
; Declare.l Print_Rectangle(x.f,y.f,w.f,h.f)
; Declare.l Print_Rectangle2(x.f,y.f,w.f,h.f,Fill.l)
; Declare.l Print_ResetDC(Option$)
; Declare.l Print_RoundRect(x1.f,y1.f,x2.f,y2.f,w.f,h.f,Fill.l)
; Declare.l Print_SetArcDirection(arcd.l)
; Declare.l Print_SetBkColor(Color.l)
; Declare.l Print_SetBkMode(Mode.l)
; Declare   Print_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
; Declare.l Print_SetLineColor(Color.l)
; Declare.l Print_SetLineStyle(Style.l)
; Declare.l Print_SetLineWidth(w.f)
; Declare   Print_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
; Declare.l Print_SetStatus(Status.l)
; Declare.l Print_SetTextAlign(Mode.l)
; Declare.l Print_SetTextColor(Color.l)
; Declare.l Print_SetTextJustification(l.f,Count.l)
; Declare.f Print_SetTextSpacing(l.f)
; Declare.l Print_SetUnits(Unit.l)
; Declare.l Print_SetX(x.f)
; Declare.l Print_SetXY(x.f,y.f)
; Declare.l Print_SetY(y.f)
; Declare.l Print_StartDoc(Jobname$)
; Declare.l Print_StartDoc2(Jobname$,OutputFileName$)
; Declare.l Print_StartDoc3(Jobname$,OutputFileName$,Datatype$)
; Declare.l Print_StartPreview(x.l)
; Declare.l Print_StartPrinting(Jobname$)
; Declare.l Print_StartPrinting2(Jobname$,Outfile$)
; Declare.l Print_StopPreview()
; Declare.l Print_StopPrinting()
; Declare.l Print_Text(x.f,y.f,Text$)
; Declare.f Print_TextHeight(Text$)
; Declare.f Print_TextWidth(Text$)
; Declare.l Print_WriteData(*Membuffer.i,Size.l)
; Declare.l Print_WriteString(String$)
; Declare.l Print_WriteStringN(String$)

Procedure ipprint_Init()
  Global NewList PrintLib_Images.l()
  Global NewList Print_Printers.s()
  Global NewList Print_Fonts.PrintLib_Fonts()
  PrintLib_DC=0
  PrintLib_PH=0
  PrintLib_pPageRanges=0
  PrintLib_Pen=0
  PrintLib_Font=0
  PrintLib_Brush=0
  PrintLib_Linewidth=0.2
  PrintLib_Linecolor=0 ; Black
  PrintLib_Linestyle=#PS_GEOMETRIC|#PS_SOLID|#PS_ENDCAP_FLAT|#PS_JOIN_MITER
  PrintLib_Units=#PRINT_MM
  PrintLib_oldDC=0
  PrintLib_Preview=0
  PrintLib_PreviewX=0
  PrintLib_PreviewY=0
  PrintLib_Brushcolor=#Black
  PrintLib_Align=#TA_LEFT|#TA_TOP|#TA_NOUPDATECP
  PrintLib_BKMode=#TRANSPARENT
  PrintLib_Debug=#False
  PrintLib_DebugFile=0
EndProcedure

Procedure ipprint_End()
  If PrintLib_PH<>0
    ClosePrinter_(PrintLib_PH)
  EndIf
  If PrintLib_pPageRanges<>0
    FreeMemory(PrintLib_pPageRanges)
  EndIf
  If PrintLib_Pen<>0
    DeleteObject_(PrintLib_Pen)
  EndIf
  If PrintLib_Font<>0 And IsFont(PrintLib_Font)<>0
    FreeFont(PrintLib_Font)
  EndIf
  If PrintLib_Brush<>0
    DeleteObject_(PrintLib_Brush)
  EndIf
  If PrintLib_oldDC<>0
    DeleteDC_(PrintLib_oldDC)
  EndIf
  If PrintLib_DC<>0
    DeleteDC_(PrintLib_DC)
  EndIf
  If PrintLib_DebugFile<>0
    CloseFile(PrintLib_DebugFile)
  EndIf
  
  ForEach PrintLib_Images()
    FreeImage(PrintLib_Images())
  Next
  
  ClearList(PrintLib_Images())
  ClearList(Print_Printers())
  ClearList(Print_Fonts())
EndProcedure

Procedure ipprint_SaveDebugInfo(Info$)
  Protected date$,FileName$,FSize
  Static file.l
  
  Debug Info$
  
  If PrintLib_Debug=#False
    ProcedureReturn
  EndIf
  
  ; save debug information to file
  If PrintLib_DebugFile=0
    date$=FormatDate("%yyyy%mm%dd_%hh%ii%ss",Date())
    FileName$="Printer_Lib_debugfile "+date$+".txt"
    PrintLib_DebugFile=CreateFile(#PB_Any,FileName$)
  EndIf
  If PrintLib_DebugFile
    FSize=Lof(PrintLib_DebugFile)
    FileSeek(PrintLib_DebugFile,FSize)
    info$+Chr(13)+Chr(10)
    If PrintLib_Preview=#True
      Info$="  "+Info$
    EndIf
    WriteString(PrintLib_DebugFile,Info$,#PB_Ascii)
  EndIf
EndProcedure

Procedure.l ipprint_ConvertUnitsToPointsX(x.f)
  Protected res.l
  
  Select PrintLib_Units
    Case #PRINT_POINTS
      res=x
    Case #PRINT_INCHES
      res=(ipprint_GetDeviceCaps(#LOGPIXELSX) * x) / 10.0
    Case #PRINT_MM
      res=(ipprint_GetDeviceCaps(#LOGPIXELSX) * x) / 25.4
    Default
      res=x
  EndSelect
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_ConvertUnitsToPointsY(y.f)
  Protected res.l
  
  Select PrintLib_Units
    Case #PRINT_POINTS
      res=y
    Case #PRINT_INCHES
      res=(ipprint_GetDeviceCaps(#LOGPIXELSY) * y) / 10.0
    Case #PRINT_MM
      res=(ipprint_GetDeviceCaps(#LOGPIXELSY) * y) / 25.4
    Default
      res=y
  EndSelect
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style)
  Protected PenType,PenStyle,PenEndCap,PenJoin,nwidth,Brush.LOGBRUSH,newpen
  ipprint_SaveDebugInfo("Print_CreatePen("+Hex(PrintLib_Linestyle,#PB_Long)+","+Hex(PrintLib_Linewidth,#PB_Long)+","+Hex(PrintLib_Linecolor,#PB_Long)+",0,0)")
  
  PenType=style & #PS_TYPE_MASK 
  PenStyle=style & #PS_STYLE_MASK
  PenEndCap=style & #PS_ENDCAP_MASK
  PenJoin=style & #PS_JOIN_MASK
  
  If w=0
    nwidth=1
  Else
    nwidth=ipprint_ConvertUnitsToPointsX(w)
  EndIf
  
  Select PenType
    Case #PS_GEOMETRIC
    Case #PS_COSMETIC
      nwidth=1
  EndSelect
  
  Select PenStyle
    Case #PS_ALTERNATE
    Case #PS_SOLID
    Case #PS_DASH
    Case #PS_DOT
    Case #PS_DASHDOT
    Case #PS_DASHDOTDOT
    Case #PS_NULL
    Case #PS_USERSTYLE
    Case #PS_INSIDEFRAME
  EndSelect
  
  Select PenEndCap
    Case #PS_ENDCAP_ROUND
    Case #PS_ENDCAP_SQUARE
    Case #PS_ENDCAP_FLAT
  EndSelect
  
  Select PenJoin
    Case #PS_JOIN_BEVEL
    Case #PS_JOIN_MITER
    Case #PS_JOIN_ROUND
  EndSelect
  
  Brush\lbstyle=#BS_SOLID
  Brush\lbcolor=Color
  Brush\lbhatch=0
  
  newpen=ExtCreatePen_(style,nwidth,Brush,Stylecount,*Style)
  ipprint_SaveDebugInfo("ExtCreatePen_("+Hex(style,#PB_Long)+","+Hex(nwidth,#PB_Long)+","+Hex(Brush,#PB_Long)+","+Hex(Stylecount,#PB_Long)+","+Hex(*Style,#PB_Long)+")="+Hex(newpen,#PB_Long))
  If newpen<>0
    DeleteObject_(PrintLib_Pen)
    PrintLib_Pen=newpen
    SelectObject_(PrintLib_DC,PrintLib_Pen)
  EndIf
  
  ProcedureReturn newpen
EndProcedure

Procedure.l ipprint_GetDeviceCaps(Type.l)
  Protected x1,x2,y1,y2
  
  If PrintLib_Preview=#True
    Select Type
        ;Case #HORZSIZE ; size in mm
        
        ;Case #VERTSIZE ; size in mm
        
      Case #HORZRES ; width in pixels
        If PrintLib_Images()
          ProcedureReturn ImageWidth(PrintLib_Images())
        EndIf
      Case #VERTRES ; height in pixels
        If PrintLib_Images()
          ProcedureReturn ImageHeight(PrintLib_Images())
        EndIf
      Case #LOGPIXELSX ; DPI-X
        If PrintLib_Images()
          x1=ImageWidth(PrintLib_Images())
          x2=GetDeviceCaps_(PrintLib_oldDC,#HORZSIZE)
          ProcedureReturn (x1*25.4)/x2
        EndIf
      Case #LOGPIXELSY ; DPI-Y
        If PrintLib_Images()
          y1=ImageHeight(PrintLib_Images())
          y2=GetDeviceCaps_(PrintLib_oldDC,#VERTSIZE)
          ProcedureReturn (y1*25.4)/y2
        EndIf
      Default
        ProcedureReturn GetDeviceCaps_(PrintLib_oldDC,Type)
    EndSelect
  Else
    ProcedureReturn GetDeviceCaps_(PrintLib_DC,Type)
  EndIf
EndProcedure

Procedure.l ipprint_SetTextAlign(Mode.l)
  Protected res
  ipprint_SaveDebugInfo("Print_SetTextAlign("+Hex(PrintLib_Align,#PB_Long)+")")
  res=SetTextAlign_(PrintLib_DC,mode)
  ipprint_SaveDebugInfo("SetTextAlign_("+Hex(PrintLib_DC,#PB_Long)+","+Hex(mode,#PB_Long)+")="+Hex(res,#PB_Long))
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_SetBkColor(Color.l)
  ProcedureReturn SetBkColor_(PrintLib_DC,color)
EndProcedure

Procedure.l ipprint_SetBkMode(Mode.l)
  Protected res
  ipprint_SaveDebugInfo("Print_SetBkMode("+Hex(PrintLib_BKMode,#PB_Long)+")")
  res=SetBkMode_(PrintLib_DC,mode)
  ipprint_SaveDebugInfo("SetBkMode_("+Hex(PrintLib_DC,#PB_Long)+","+Hex(mode,#PB_Long)+")="+Str(res))
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_SetLineColor(Color.l)
  ipprint_SaveDebugInfo("Print_SetLineColor("+Hex(PrintLib_Linecolor,#PB_Long)+")")
  PrintLib_Linecolor=color
  ProcedureReturn ipprint_CreatePen(PrintLib_Linestyle,PrintLib_Linewidth,PrintLib_Linecolor,0,0)
EndProcedure

Procedure ipprint_Standardsettings()
  ipprint_SetTextAlign(PrintLib_Align)
  ipprint_SetBkMode(PrintLib_BKMode)
  ipprint_SetLineColor(PrintLib_Linecolor)
  ipprint_CreateBrush(PrintLib_Brushcolor)
  ipprint_CreatePen(PrintLib_Linestyle,PrintLib_Linewidth,PrintLib_Linecolor,0,0)
EndProcedure

Procedure.l ipprint_SetUnits(Unit.l)
  Protected old
  old=PrintLib_Units
  PrintLib_Units=Unit
  ProcedureReturn old
EndProcedure

Procedure.l ipprint_GetUnits()
  ProcedureReturn PrintLib_Units
EndProcedure

Procedure.f ipprint_ConvertPointsToUnitsX(x.l)
  Protected res.f
  Select PrintLib_Units
    Case #PRINT_POINTS
      res=x
    Case #PRINT_INCHES
      res=(x * 10.0) / ipprint_GetDeviceCaps(#LOGPIXELSX)
    Case #PRINT_MM
      res=(x * 25.4) / ipprint_GetDeviceCaps(#LOGPIXELSX)
    Default
      res=x
  EndSelect
  
  ProcedureReturn res
EndProcedure

Procedure.f ipprint_ConvertPointsToUnitsY(y.l)
  Protected res.f
  Select PrintLib_Units
    Case #PRINT_POINTS
      res=y
    Case #PRINT_INCHES
      res=(y * 10.0) / ipprint_GetDeviceCaps(#LOGPIXELSY)
    Case #PRINT_MM
      res=(y * 25.4) / ipprint_GetDeviceCaps(#LOGPIXELSY)
    Default
      res=y
  EndSelect
  
  ProcedureReturn res
EndProcedure

Procedure.f ipprint_TextHeight(Text$)
  Protected Text.SIZE
  GetTextExtentPoint32_(PrintLib_DC,Text$,Len(Text$),Text.SIZE)
  ProcedureReturn ipprint_ConvertPointsToUnitsY(Text\cy)
EndProcedure

Procedure.f ipprint_TextWidth(Text$)
  Protected Text.SIZE
  GetTextExtentPoint32_(PrintLib_DC,Text$,Len(Text$),Text.SIZE)
  ProcedureReturn ipprint_ConvertPointsToUnitsX(Text\cx)
EndProcedure

Procedure.f ipprint_GetTextMetrics(Type.l)
  Protected res.f,TM.TEXTMETRIC,px,py
  
  GetTextMetrics_(PrintLib_DC,TM.TEXTMETRIC)
  
  px=ipprint_GetDeviceCaps(#LOGPIXELSX)
  py=ipprint_GetDeviceCaps(#LOGPIXELSY)
  
  Select Type
    Case #TM_HEIGHT
      res=ipprint_ConvertPointsToUnitsY(TM\tmHeight)
    Case #TM_ASCENT
      res=ipprint_ConvertPointsToUnitsY(TM\tmAscent)
    Case #TM_DESCENT
      res=ipprint_ConvertPointsToUnitsY(TM\tmDescent)
    Case #TM_INTERNALLEADING
      res=ipprint_ConvertPointsToUnitsY(TM\tmInternalLeading)
    Case #TM_EXTERNALLEADING
      res=ipprint_ConvertPointsToUnitsY(TM\tmExternalLeading)
    Case #TM_AVECHARWIDTH
      res=ipprint_ConvertPointsToUnitsX(TM\tmAveCharWidth)
    Case #TM_MAXCHARWIDTH
      res=ipprint_ConvertPointsToUnitsX(TM\tmMaxCharWidth)
    Case #TM_WEIGHT
      res=ipprint_ConvertPointsToUnitsY(TM\tmWeight)
    Case #TM_OVERHANG
      res=ipprint_ConvertPointsToUnitsY(TM\tmOverhang)
    Case #TM_DIGITIZEDASPECTX
      res=ipprint_ConvertPointsToUnitsX(TM\tmDigitizedAspectX)
    Case #TM_DIGITIZEDASPECTY
      res=ipprint_ConvertPointsToUnitsY(TM\tmDigitizedAspectY)
    Case #TM_FIRSTCHAR
      res=TM\tmFirstChar
    Case #TM_LASTCHAR
      res=TM\tmLastChar
    Case #TM_DEFAULTCHAR
      res=TM\tmDefaultChar
    Case #TM_BREAKCHAR
      res=TM\tmBreakChar
    Case #TM_ITALIC
      res=TM\tmItalic
    Case #TM_UNDERLINED
      res=TM\tmUnderLined
    Case #TM_STRUCKOUT
      res=TM\tmStruckOut
    Case #TM_PITCHANDFAMILY
      res=TM\tmPitchAndFamily
    Case #TM_CHARSET
      res=TM\tmCharSet
  EndSelect
  
  ProcedureReturn res
EndProcedure

Procedure.f ipprint_GetOutlineTextMetrics(Type.l)
  Protected res.f,size,OTM.OUTLINETEXTMETRIC,px,py
  
  size=SizeOf(OUTLINETEXTMETRIC)
  GetOutlineTextMetrics_(PrintLib_DC,size,OTM.OUTLINETEXTMETRIC)
  
  px=ipprint_GetDeviceCaps(#LOGPIXELSX)
  py=ipprint_GetDeviceCaps(#LOGPIXELSY)
  
  Select Type
    Case #TM_HEIGHT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmHeight)
    Case #TM_ASCENT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmAscent)
    Case #TM_DESCENT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmDescent)
    Case #TM_INTERNALLEADING
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmInternalLeading)
    Case #TM_EXTERNALLEADING
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmExternalLeading)
    Case #TM_AVECHARWIDTH
      res=ipprint_ConvertPointsToUnitsX(OTM\otmTextMetrics\tmAveCharWidth)
    Case #TM_MAXCHARWIDTH
      res=ipprint_ConvertPointsToUnitsX(OTM\otmTextMetrics\tmMaxCharWidth)
    Case #TM_WEIGHT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmWeight)
    Case #TM_OVERHANG
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmOverhang)
    Case #TM_DIGITIZEDASPECTX
      res=ipprint_ConvertPointsToUnitsX(OTM\otmTextMetrics\tmDigitizedAspectX)
    Case #TM_DIGITIZEDASPECTY
      res=ipprint_ConvertPointsToUnitsY(OTM\otmTextMetrics\tmDigitizedAspectY)
    Case #TM_FIRSTCHAR
      res=OTM\otmTextMetrics\tmFirstChar
    Case #TM_LASTCHAR
      res=OTM\otmTextMetrics\tmLastChar
    Case #TM_DEFAULTCHAR
      res=OTM\otmTextMetrics\tmDefaultChar
    Case #TM_BREAKCHAR
      res=OTM\otmTextMetrics\tmBreakChar
    Case #TM_ITALIC
      res=OTM\otmTextMetrics\tmItalic
    Case #TM_UNDERLINED
      res=OTM\otmTextMetrics\tmUnderLined
    Case #TM_STRUCKOUT
      res=OTM\otmTextMetrics\tmStruckOut
    Case #TM_PITCHANDFAMILY
      res=OTM\otmTextMetrics\tmPitchAndFamily
    Case #TM_CHARSET
      res=OTM\otmTextMetrics\tmCharSet
    Case #OTM_FILLER
      res=OTM\otmFiller
    Case #OTM_PANOSE_TYPE
      res=OTM\otmPanoseNumber\bFamilyType
    Case #OTM_PANOSE_STYLE
      res=OTM\otmPanoseNumber\bSerifStyle
    Case #OTM_PANOSE_WEIGHT
      res=OTM\otmPanoseNumber\bWeight
    Case #OTM_PANOSE_PROPORTION
      res=OTM\otmPanoseNumber\bProportion
    Case #OTM_PANOSE_CONTRAST
      res=OTM\otmPanoseNumber\bContrast
    Case #OTM_PANOSE_STROKEV
      res=OTM\otmPanoseNumber\bStrokeVariation
    Case #OTM_PANOSE_ARMSTYLE
      res=OTM\otmPanoseNumber\bArmStyle
    Case #OTM_PANOSE_LETTERFORM
      res=OTM\otmPanoseNumber\bLetterform
    Case #OTM_PANOSE_MIDLINE
      res=OTM\otmPanoseNumber\bMidLine
    Case #OTM_PANOSE_XHEIGHT
      res=OTM\otmPanoseNumber\bXHeight
    Case #OTM_FSSELECTION
      res=OTM\otmfsSelection
    Case #OTM_FSTYPE
      res=OTM\otmfsType
    Case #OTM_SCHARSLOPERISE
      res=OTM\otmsCharSlopeRise
    Case #OTM_SCHARSLOPERUN
      res=OTM\otmsCharSlopeRun
    Case #OTM_IIALICANGLE
      res=OTM\otmItalicAngle
    Case #OTM_EMSQUARE
      res=ipprint_ConvertPointsToUnitsY(OTM\otmEMSquare)
    Case #OTM_ASCENT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmAscent)
    Case #OTM_DESCENT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmDescent)
    Case #OTM_LINEGAP
      res=ipprint_ConvertPointsToUnitsY(OTM\otmLineGap)
    Case #OTM_CAPEMHEIGHT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmsCapEmHeight)
    Case #OTM_XHEIGHT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmsXHeight)
    Case #OTM_RCFONTBOX_LEFT
      res=OTM\otmrcFontBox\left
    Case #OTM_RCFONTBOX_TOP
      res=OTM\otmrcFontBox\top
    Case #OTM_RCFONTBOX_RIGHT
      res=OTM\otmrcFontBox\right
    Case #OTM_RCFONTBOX_BOTTOM
      res=OTM\otmrcFontBox\bottom
    Case #OTM_MACASCENT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmMacAscent)
    Case #OTM_MACDESCENT
      res=ipprint_ConvertPointsToUnitsY(OTM\otmMacDescent)
    Case #OTM_MACLINEGAP
      res=ipprint_ConvertPointsToUnitsY(OTM\otmMacLineGap)
    Case #OTM_USMINIMUMPPEM
      res=OTM\otmusMinimumPPEM
    Case #OTM_PTSUBSCRIPTSIZEX
      res=OTM\otmptSubScriptSize\x
    Case #OTM_PTSUBSCRIPTSIZEY
      res=OTM\otmptSubScriptSize\y
    Case #OTM_PTSUBSCRIPTOFFSETX
      res=OTM\otmptSubScriptOffset\x
    Case #OTM_PTSUBSCRIPTOFFSETY
      res=OTM\otmptSubScriptOffset\y
    Case #OTM_PTSUPERSCRIPTSIZEX
      res=OTM\otmptSuperScriptSize\x
    Case #OTM_PTSUPERSCRIPTSIZEY
      res=OTM\otmptSuperScriptSize\y
    Case #OTM_PTSUPERSCRIPTOFFSETX
      res=OTM\otmptSuperScriptOffset\x
    Case #OTM_PTSUPERSCRIPTOFFSETY
      res=OTM\otmptSuperScriptOffset\y
    Case #OTM_SSTRIKEOUTSIZE
      res=OTM\otmsStrikeoutSize
    Case #OTM_SSTRIKEOUTPOSITION
      res=OTM\otmsStrikeoutPosition
    Case #OTM_SUNDERSCORESIZE
      res=OTM\otmsUnderscorePosition
    Case #OTM_SUNDERSCOREPOSITION
      res=OTM\otmsUnderscoreSize
    Case #OTM_PFAMILYNAME
      res=OTM\otmpFamilyName
    Case #OTM_PFACENAME
      res=OTM\otmpFaceName
    Case #OTM_PSTYLENAME
      res=OTM\otmpStyleName
    Case #OTM_PFULLNAME
      res=OTM\otmpFullName
  EndSelect
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_Font(Font$,Height.l,Flags.l=0,Rotate.l=0)
  Protected font.LOGFONT,newfont
  
  ;http://msdn.microsoft.com/library/en-us/gdi/fontext_4rw4.asp
  font\lfHeight=(Height*ipprint_GetDeviceCaps(#LOGPIXELSY))/72
  font\lfWidth=0
  font\lfEscapement=Rotate
  font\lfOrientation=Rotate
  font\lfWeight=#FW_NORMAL
  If Flags & #PB_Font_Bold
    font\lfWeight=#FW_BOLD
  Else
    font\lfWeight=#FW_NORMAL
  EndIf
  If flags & #PB_Font_Italic
    font\lfItalic=#True
  EndIf
  If flags & #PB_Font_Underline
    font\lfUnderline=#True
  EndIf
  If flags & #PB_Font_StrikeOut
    font\lfStrikeOut=#True
  EndIf
  font\lfCharSet=#DEFAULT_CHARSET
  font\lfOutPrecision=#OUT_DEFAULT_PRECIS
  font\lfClipPrecision=#CLIP_DEFAULT_PRECIS
  If flags & #PB_Font_HighQuality
    If flags & 1
      font\lfQuality=#ANTIALISED_QUALITY
    ElseIf flags & 2
      font\lfQuality=#CLEARTYPE_QUALITY
    Else
      font\lfQuality=#PROOF_QUALITY
    EndIf
  Else
    If flags & 1
      font\lfQuality=#DRAFT_QUALITY
    Else
      font\lfQuality=#DEFAULT_QUALITY
    EndIf
  EndIf
  font\lfPitchAndFamily=#DEFAULT_PITCH | #FF_DONTCARE
  PokeS(@font\lfFaceName,Font$,31)
  
  newfont=CreateFontIndirect_(font)
  
  If newfont<>0
    PrintLib_FontName$=Font$
    PrintLib_FontHeight=Height
    PrintLib_FontFlags=Flags
    PrintLib_FontRotate=Rotate
    DeleteObject_(PrintLib_Font)
    PrintLib_Font=newfont
    SelectObject_(PrintLib_DC,PrintLib_Font)
  EndIf
  
  ProcedureReturn PrintLib_Font
EndProcedure

Procedure.l ipprint_Text(x.f,y.f,Text$)
  Protected startx,starty
  
  startx=ipprint_ConvertUnitsToPointsX(x)
  starty=ipprint_ConvertUnitsToPointsY(y)
  ProcedureReturn TextOut_(PrintLib_DC,startx,starty,text$,Len(text$))
EndProcedure

Procedure.s ipprint_GetDeviceCapabilities(Type.l,Separator$="|")
  Protected res$,count,*buffer,i,lres
  
  Select Type
    Case #DC_PERSONALITY
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      If count>0
        *buffer=AllocateMemory(count*(32*SizeOf(Character)))
        If *buffer
          If DeviceCapabilities_(@PrintLib_PN,0,Type,*buffer,0)
            For i=0 To count-1
              If i<>0
                res$+Separator$
              EndIf
              res$+PeekS(*buffer+i*(32*SizeOf(Character)),32)
            Next
          EndIf
          FreeMemory(*buffer)
        EndIf 
      EndIf
    Case #DC_MAXEXTENT,#DC_MINEXTENT
      lres=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      count=2
      res$=StrU(PeekW(@lres+0),#PB_Word)+Separator$
      res$+StrU(PeekW(@lres+2),#PB_Word)
    Case #DC_FILEDEPENDENCIES,#DC_MEDIAREADY,#DC_MEDIATYPENAMES,#DC_PAPERNAMES
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      If count>0
        *buffer=AllocateMemory(count*(64*SizeOf(Character)))
        If *buffer
          If DeviceCapabilities_(@PrintLib_PN,0,Type,*buffer,0)
            For i=0 To count-1
              If i<>0
                res$+Separator$
              EndIf
              res$+PeekS(*buffer+i*(64*SizeOf(Character)),64)
            Next
          EndIf
          FreeMemory(*buffer)
        EndIf 
      EndIf
    Case #DC_ENUMRESOLUTIONS,#DC_PAPERSIZE
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      If count>0
        *buffer=AllocateMemory(count*8)
        If *buffer
          If DeviceCapabilities_(@PrintLib_PN,0,Type,*buffer,0)
            For i=0 To count-1
              If i<>0
                res$+Separator$
              EndIf
              res$+StrU(PeekL(*buffer+i*8),#PB_Long)+"X"+StrU(PeekL(*buffer+4+i*8),#PB_Long)
            Next
          EndIf
          FreeMemory(*buffer)
        EndIf 
      EndIf
    Case #DC_COPIES,#DC_COLORDEVICE,#DC_COLLATE,#DC_DRIVER,#DC_DUPLEX,#DC_EXTRA,#DC_ORIENTATION,#DC_PRINTERMEM,#DC_PRINTRATE,#DC_PRINTRATEPPM,#DC_PRINTRATEUNIT,#DC_SIZE,#DC_STAPLE,#DC_TRUETYPE,#DC_VERSION
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
    Case #DC_BINS,#DC_PAPERS
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      If count>0
        *buffer=AllocateMemory(count*2)
        If *buffer
          If DeviceCapabilities_(@PrintLib_PN,0,Type,*buffer,0)
            For i=0 To count-1
              If i<>0
                res$+Separator$
              EndIf
              res$+StrU(PeekW(*buffer+i*2),#PB_Word)
            Next
          EndIf
          FreeMemory(*buffer)
        EndIf 
      EndIf
    Case #DC_BINNAMES
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      If count>0
        *buffer=AllocateMemory(count*(24*SizeOf(Character)))
        If *buffer
          If DeviceCapabilities_(@PrintLib_PN,0,Type,*buffer,0)
            For i=0 To count-1
              If i<>0
                res$+Separator$
              EndIf
              res$+PeekS(*buffer+i*(24*SizeOf(Character)),24)
            Next
          EndIf
          FreeMemory(*buffer)
        EndIf
      EndIf
    Case #DC_NUP,#DC_MEDIATYPES
      count=DeviceCapabilities_(@PrintLib_PN,0,Type,#Null,0)
      If count>0
        *buffer=AllocateMemory(count*4)
        If *buffer>0
          If DeviceCapabilities_(@PrintLib_PN,0,Type,*buffer,0)>0
            For i=0 To count-1
              If i<>0
                res$+Separator$
              EndIf
              res$+Str(PeekL(*buffer+i*4))
            Next
          EndIf
          FreeMemory(*buffer)
        EndIf
      EndIf
  EndSelect
  
  If res$<>""
    ProcedureReturn Str(count)+Separator$+res$
  Else
    ProcedureReturn Str(count)
  EndIf
EndProcedure

Procedure ipprint_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
  Protected Flags,cnt,i,part$,opt$,value
  
  cnt=CountString(Option$,",")
  For i=0 To cnt
    part$=StringField(Option$,i+1,",")
    opt$=StringField(part$,1,"=")
    value=Val(StringField(part$,2,"="))
    Select UCase(opt$)
      Case "ORIENTATION"
        *PrinterParameters\dmFields|#DM_ORIENTATION
        *PrinterParameters\dmOrientation=value
      Case "PAPERSIZE"
        *PrinterParameters\dmFields|#DM_PAPERSIZE
        *PrinterParameters\dmPapersize=value
      Case "PAPERLENGTH"
        *PrinterParameters\dmFields|#DM_PAPERLENGTH
        *PrinterParameters\dmPaperlength=value
      Case "PAPERWIDTH"
        *PrinterParameters\dmFields|#DM_PAPERWIDTH
        *PrinterParameters\dmPaperwidth=value
      Case "SCALE"
        *PrinterParameters\dmFields|#DM_SCALE
        *PrinterParameters\dmScale=value
      Case "COPIES"
        *PrinterParameters\dmFields|#DM_COPIES
        *PrinterParameters\dmCopies=value
      Case "DEFAULTSOURCE"
        *PrinterParameters\dmFields|#DM_DEFAULTSOURCE
        *PrinterParameters\dmDefaultsource=value
      Case "PRINTQUALITY"
        *PrinterParameters\dmFields|#DM_PRINTQUALITY
        *PrinterParameters\dmPrintquality=value
      Case "COLOR"
        *PrinterParameters\dmFields|#DM_COLOR
        *PrinterParameters\dmColor=value
      Case "DUPLEX"
        *PrinterParameters\dmFields|#DM_DUPLEX
        *PrinterParameters\dmDuplex=value
      Case "YRESOLUTION"
        *PrinterParameters\dmFields|#DM_YRESOLUTION
        *PrinterParameters\dmYResolution=value
      Case "TTOPTION"
        *PrinterParameters\dmFields|#DM_TTOPTION
        *PrinterParameters\dmTTOption=value
      Case "COLLATE"
        *PrinterParameters\dmFields|#DM_COLLATE
        *PrinterParameters\dmCollate=value
    EndSelect
  Next
EndProcedure

Procedure.l ipprint_SetPRINTDLG(Option$,*PrinterParameters.PRINTDLG)
  Protected Flags.l,cnt,i,part$,opt$,value
  
  cnt=CountString(Option$,",")
  For i=0 To cnt
    part$=StringField(Option$,i+1,",")
    opt$=StringField(part$,1,"=")
    value=Val(StringField(part$,2,"="))
    Select UCase(opt$)
      Case "FLAGS"
        *PrinterParameters\Flags=value
      Case "NFROMPAGE"
        *PrinterParameters\nFromPage=value
      Case "NTOPAGE"
        *PrinterParameters\nToPage=value
      Case "NMINPAGE"
        *PrinterParameters\nMinPage=value
      Case "NMAXPAGE"
        *PrinterParameters\nMaxPage=value
      Case "NCOPIES"
        *PrinterParameters\nCopies=value
      Case "HINSTANCE"
        *PrinterParameters\hInstance=value
      Case "LCUSTDATA"
        *PrinterParameters\lCustData=value
      Case "LPFNPRINTHOOK"
        *PrinterParameters\lpfnPrintHook=value
      Case "LPFNSETUPHOOK"
        *PrinterParameters\lpfnSetupHook=value
      Case "LPPRINTTEMPLATENAME"
        *PrinterParameters\lpPrintTemplateName=value
      Case "LPSETUPTEMPLATENAME"
        ;*PrinterParameters\lpPrintSetupTemplateName=value
        *PrinterParameters\pPrintSetupTemplateName=value
        ;*PrinterParameters\lpSetupTemplateName=value
      Case "HPRINTTEMPLATE"
        *PrinterParameters\hPrintTemplate=value
      Case "HSETUPTEMPLATE"
        *PrinterParameters\hSetupTemplate=value
    EndSelect
  Next
  
  ProcedureReturn Flags
EndProcedure

Procedure ipprint_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
  Protected cnt,i,part$,opt$,value
  
  cnt=CountString(Option$,",")
  For i=0 To cnt
    part$=StringField(Option$,i+1,",")
    opt$=StringField(part$,1,"=")
    value=Val(StringField(part$,2,"="))
    Select UCase(opt$)
      Case "FLAGS"
        *PrinterParameters\Flags=value
      Case "EXCLUSIONFLAGS"
        *PrinterParameters\ExclusionFlags=value
      Case "NPAGERANGES"
        *PrinterParameters\nPageRanges=value
      Case "NMAXPAGERANGES"
        *PrinterParameters\nMaxPageRanges=value
      Case "LPPAGERANGES"
        *PrinterParameters\lpPageRanges=value
      Case "NMINPAGE"
        *PrinterParameters\nMinPage=value
      Case "NMAXPAGE"
        *PrinterParameters\nMaxPage=value
      Case "NCOPIES"
        *PrinterParameters\nCopies=value
      Case "HINSTANCE"
        *PrinterParameters\hInstance=value
      Case "LPPRINTTEMPLATENAME"
        *PrinterParameters\lpPrintTemplateName=value
      Case "LPCALLBACK"
        *PrinterParameters\lpCallback=value
      Case "NPROPERTYPAGES"
        *PrinterParameters\nPropertyPages=value
      Case "LPHPROPERTYPAGES"
        *PrinterParameters\lphPropertyPages=value
      Case "NSTARTPAGE"
        *PrinterParameters\nStartPage=value
    EndSelect
  Next
EndProcedure

Procedure.l ipprint_LoadDEVMODE(Filename$)
  Protected Size,file,mem
  
  Size=FileSize(Filename$)
  If Size>0
    file=ReadFile(#PB_Any,Filename$)
    If file
      If *PrintLibDEVMODE
        FreeMemory(*PrintLibDEVMODE)
      EndIf
      mem=AllocateMemory(Size)
      If mem
        *PrintLibDEVMODE=mem
        *PrintLibDEVMODESize=Size
        ReadData(file,*PrintLibDEVMODE,Size)
        ResetDC_(PrintLib_DC,*PrintLibDEVMODE)
        ;res=DocumentProperties_(hwnd,PrintLib_PH,PrintLib_PN,*PrintLibDEVMODE,*PrintLibDEVMODE,#DM_OUT_BUFFER|#DM_IN_BUFFER)
      Else
        *PrintLibDEVMODE=0
        *PrintLibDEVMODESize=0
      EndIf
      CloseFile(file)
    EndIf
  EndIf
  
  ProcedureReturn *PrintLibDEVMODE
EndProcedure

Procedure.l ipprint_SaveDEVMODE(Filename$)
  Protected File
  
  If *PrintLibDEVMODE And *PrintLibDEVMODESize
    File=CreateFile(#PB_Any,Filename$)
    If File
      WriteData(File,*PrintLibDEVMODE,*PrintLibDEVMODESize)
      CloseFile(File)
      ProcedureReturn *PrintLibDEVMODE
    EndIf
  EndIf
EndProcedure

Procedure ipprint_GeneralDebugInfo()
  ipprint_SaveDebugInfo("Printer-Lib Version "+#PrinterLib_Version)
  ipprint_SaveDebugInfo("PureBasic Version "+Str(#PB_Compiler_Version))
  Select OSVersion()
    Case #PB_OS_Windows_NT3_51
      ipprint_SaveDebugInfo("Windows_NT3_51")
    Case #PB_OS_Windows_95
      ipprint_SaveDebugInfo("Windows_95")
    Case #PB_OS_Windows_NT_4
      ipprint_SaveDebugInfo("Windows_NT_4")
    Case #PB_OS_Windows_98
      ipprint_SaveDebugInfo("Windows_98")
    Case #PB_OS_Windows_ME
      ipprint_SaveDebugInfo("Windows_ME")
    Case #PB_OS_Windows_2000
      ipprint_SaveDebugInfo("Windows_2000")
    Case #PB_OS_Windows_XP
      ipprint_SaveDebugInfo("Windows_XP")
    Case #PB_OS_Windows_Server_2003
      ipprint_SaveDebugInfo("Windows_Server_2003")
    Case #PB_OS_Windows_Vista
      ipprint_SaveDebugInfo("Windows_Vista")
    Case #PB_OS_Windows_Server_2008
      ipprint_SaveDebugInfo("Windows_Server_2008")
    Case #PB_OS_Windows_7
      ipprint_SaveDebugInfo("Windows_7")
    Case #PB_OS_Windows_Server_2008_R2
      ipprint_SaveDebugInfo("Windows_Server_2008_R2")
    Case #PB_OS_Windows_8
      ipprint_SaveDebugInfo("Windows_8")
    Case #PB_OS_Windows_Server_2012
      ipprint_SaveDebugInfo("Windows_Server_2012")
    Default ; neue Windows Version (nicht existent, als das Programm geschrieben wurde)
      ipprint_SaveDebugInfo("Windows_Future")
  EndSelect
EndProcedure

Procedure.l ipprint_OpenPrinter(PrinterName$="",Option$="",Access.l=0)
  Protected pdef.PRINTER_DEFAULTS,res,Buffersize,lpszDriver.s
  
  ipprint_GeneralDebugInfo()
  
  If PrintLib_DC<>0
    DeleteDC_(PrintLib_DC)
    PrintLib_DC=0
  EndIf
  If PrintLib_PH<>0
    ClosePrinter_(PrintLib_PH)
    PrintLib_PH=0
  EndIf
  
  If PrinterName$=""
    PrintLib_PN=ipprint_GetDefaultPrinter()
  Else
    PrintLib_PN=PrinterName$
  EndIf
  
  ipprint_SaveDebugInfo("Printer : "+PrintLib_PN)
  
  If Access<>0
    pdef\pDatatype=0
    pdef\pDevMode=0
    pdef\DesiredAccess=Access
    res=OpenPrinter_(PrintLib_PN,@PrintLib_PH,pdef)
  Else
    res=OpenPrinter_(PrintLib_PN,@PrintLib_PH,0)
  EndIf
  
  ipprint_SaveDebugInfo("OpenPrinter_()="+Hex(res,#PB_Long))
  
  If res
    Buffersize=DocumentProperties_(0,PrintLib_PH,PrintLib_PN,0,0,0)
    If (*PrintLibDEVMODE And *PrintLibDEVMODESize<>Buffersize) Or *PrintLibDEVMODE=0
      If *PrintLibDEVMODE
        FreeMemory(*PrintLibDEVMODE)
      EndIf
      *PrintLibDEVMODE=AllocateMemory(Buffersize)
      *PrintLibDEVMODESize=Buffersize
      DocumentProperties_(0,PrintLib_PH,PrintLib_PN,*PrintLibDEVMODE,0,#DM_OUT_BUFFER)
    EndIf
    
    If Option$<>""
      ipprint_SetDEVMODE(Option$,*PrintLibDEVMODE)
    EndIf
    
    If GetVersion_()&$FF0000 ; Windows NT/XP
      lpszDriver = "WINSPOOL"
    Else ; Win 9x/Me
      lpszDriver = ""
    EndIf
    PrintLib_DC=CreateDC_(@lpszDriver,@PrintLib_PN,0,*PrintLibDEVMODE)
    If PrintLib_DC<>0
      ipprint_Standardsettings()
    EndIf
    
    ProcedureReturn PrintLib_DC
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.l ipprint_ResetDC(Option$)
  Protected DC,Buffersize,*DevBufferIn,*DevBufferOut,*PrinterParameters.DEVMODE
  
  If PrintLib_Preview=#True
    DC=PrintLib_oldDC
  Else
    DC=PrintLib_DC
  EndIf
  
  If DC<>0 And Option$<>"" And PrintLib_PN<>""
    Buffersize=DocumentProperties_(0,PrintLib_PH,PrintLib_PN,0,0,0)
    If Buffersize=<0
      ProcedureReturn 0
    EndIf
    *DevBufferIn=AllocateMemory(Buffersize)
    *DevBufferOut=AllocateMemory(Buffersize)
    DocumentProperties_(0,PrintLib_PH,PrintLib_PN,*DevBufferIn,*DevBufferOut,#DM_OUT_BUFFER|#DM_IN_BUFFER)
    *PrinterParameters=*DevBufferIn
    
    ipprint_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
    
    DC=ResetDC_(DC,*PrinterParameters)
    
    FreeMemory(*DevBufferIn)
    FreeMemory(*DevBufferOut)
  EndIf
  
  ProcedureReturn DC
EndProcedure

Procedure.s ipprint_GetDefaultPrinter()
  Protected Len,winspool
  
  PrintLib_PN=""
  If OSVersion()<#PB_OS_Windows_2000
    Len=1024
    PrintLib_PN=Space(Len)
    GetPrivateProfileString_("WINDOWS","DEVICE","",@PrintLib_PN,Len,"Win.Ini")
    PrintLib_PN=StringField(PrintLib_PN,1,",")
  Else
    winspool=OpenLibrary(#PB_Any,"WINSPOOL.DRV")
    If winspool
      Len=0
      ; ANSI part
      CompilerIf #PB_Compiler_Unicode
        If CallFunction(winspool,"GetDefaultPrinterW",0,@Len)=0 And GetLastError_()=#ERROR_INSUFFICIENT_BUFFER
          PrintLib_PN=Space(Len)
          CallFunction(winspool,"GetDefaultPrinterW",@PrintLib_PN,@Len)
          If GetLastError_()=#ERROR_FILE_NOT_FOUND
            PrintLib_PN="" ; There is no default printer.
          EndIf
        EndIf
      CompilerElse
        If CallFunction(winspool,"GetDefaultPrinterA",0,@Len)=0 And GetLastError_()=#ERROR_INSUFFICIENT_BUFFER
          PrintLib_PN=Space(Len+2)
          CallFunction(winspool,"GetDefaultPrinterA",@PrintLib_PN,@Len)
          If GetLastError_()=#ERROR_FILE_NOT_FOUND
            PrintLib_PN="" ; There is no default printer.
          EndIf
        EndIf
      CompilerEndIf
      CloseLibrary(winspool)
    EndIf
  EndIf
  ProcedureReturn PrintLib_PN
EndProcedure

Procedure.l ipprint_StartPrinting(Jobname$,Outfile$)
  Protected DocInf.DOCINFO,id
  
  ipprint_SaveDebugInfo("Print_StartPrinting("+Jobname$+","+Outfile$+")")
  
  DocInf\cbSize=SizeOf(DOCINFO)
  If Jobname$=""
    DocInf\lpszDocName=0
  Else
    DocInf\lpszDocName=@Jobname$
  EndIf
  If Outfile$=""
    DocInf\lpszOutput=0
  Else
    DocInf\lpszOutput=@Outfile$
  EndIf
  DocInf\lpszDatatype=0
  DocInf\fwType=0
  
  id=StartDoc_(PrintLib_DC,DocInf)
  ipprint_SaveDebugInfo("StartDoc_("+Hex(PrintLib_DC,#PB_Long)+","+Hex(DocInf,#PB_Long)+")="+Hex(id,#PB_Long))
  If id>0
    If StartPage_(PrintLib_DC)
      ProcedureReturn id
    EndIf
  EndIf
EndProcedure

Procedure.l ipprint_NewPage()
  Protected x1,y1,dpix,dpiy,x,newbrush,oldbrush,lprc.RECT
  
  If PrintLib_Preview=#True
    StopDrawing()
    AddElement(PrintLib_Images())
    x1=GetDeviceCaps_(PrintLib_oldDC,#HORZRES)
    y1=GetDeviceCaps_(PrintLib_oldDC,#VERTRES)
    dpix=GetDeviceCaps_(PrintLib_oldDC,#LOGPIXELSX)
    dpiy=GetDeviceCaps_(PrintLib_oldDC,#LOGPIXELSY)
    x=PrintLib_PreviewX
    PrintLib_PreviewY=((x*y1)/x1)*(dpix/dpiy)
    PrintLib_Images()=CreateImage(#PB_Any,PrintLib_PreviewX,PrintLib_PreviewY,24)
    PrintLib_DC=StartDrawing(ImageOutput(PrintLib_Images()))
    ; Fill background with white
    newbrush=CreateSolidBrush_(#White)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
    lprc\left=0
    lprc\Top=0
    lprc\right=PrintLib_PreviewX
    lprc\bottom=PrintLib_PreviewY
    FillRect_(PrintLib_DC,lprc,newbrush)
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
    ipprint_Standardsettings()
  Else
    ProcedureReturn EndPage_(PrintLib_DC)
  EndIf
EndProcedure

Procedure.l ipprint_StopPrinting()
  EndPage_(PrintLib_DC)
  If EndDoc_(PrintLib_DC)<>0
    ProcedureReturn #True
  EndIf
  ProcedureReturn #False
EndProcedure

Procedure.l ipprint_Properties(Window.i=0)
  Protected hwnd
  If IsWindow(Window)
    hwnd=WindowID(Window)
  Else
    hwnd=0
  EndIf
  ProcedureReturn PrinterProperties_(hwnd,PrintLib_PH)
EndProcedure

Procedure.l ipprint_AdvancedProperties(Window.i)
  Protected hwnd,dummy
  
  If IsWindow(Window)
    hwnd=WindowID(Window)
  Else
    hwnd=0
  EndIf
  ProcedureReturn AdvancedDocumentProperties_(0,PrintLib_PH,PrintLib_PN,@dummy,0)
EndProcedure

Procedure.l ipprint_PrintDlg(Window.i=0,PrinterName$="",Option1$="",Option2$="")
  Protected hwnd,res,Buffersize,hGmem1,hGmem2,*DevBuffer,*DevNames,*PrinterParameters.DEVMODE,*PrinterNames.DEVNAMES
  
  If IsWindow(Window)
    hwnd=WindowID(Window)
  Else
    hwnd=0
  EndIf
  
  If PrinterName$=""
    PrintLib_PN=ipprint_GetDefaultPrinter()
  Else
    PrintLib_PN=PrinterName$
  EndIf
  
  If PrintLib_PH<>0
    ClosePrinter_(PrintLib_PH)
    PrintLib_PH=0
  EndIf
  
  res=OpenPrinter_(PrintLib_PN,@PrintLib_PH,0)
  If res
    Buffersize=DocumentProperties_(0,PrintLib_PH,PrintLib_PN,0,0,0)
    If Buffersize=<0
      ProcedureReturn 0
    EndIf
    
    hGmem1 = GlobalAlloc_(#GMEM_MOVEABLE|#GMEM_ZEROINIT, Buffersize)
    hGmem2 = GlobalAlloc_(#GMEM_MOVEABLE|#GMEM_ZEROINIT, 1024+SizeOf(DEVNAMES))
    Debug "GlobalSize_(hGmem1)="+Str(GlobalSize_(hGmem1))
    Debug "GlobalSize_(hGmem2)="+Str(GlobalSize_(hGmem2))
    
    *DevBuffer=GlobalLock_(hGmem1);AllocateMemory(Buffersize)
    *DevNames=GlobalLock_(hGmem2);AllocateMemory(1024+SizeOf(DEVNAMES))
    GlobalUnlock_(hGmem1)
    GlobalUnlock_(hGmem2)
    DocumentProperties_(0,PrintLib_PH,@PrintLib_PN,*DevBuffer,0,#DM_OUT_BUFFER)
    
    *PrinterParameters=*DevBuffer
    *PrinterNames=*DevNames
    
    ipprint_SetDEVMODE(Option1$,*PrinterParameters)
    
    ;PrintLibDLG.PRINTDLG
    ipprint_SetPRINTDLG(Option2$,PrintLibDLG)
    PrintLibDLG\lStructSize=SizeOf(PRINTDLG)
    PrintLibDLG\hWndOwner=hwnd
    PrintLibDLG\hDevMode=hGmem1
    PrintLibDLG\hDevNames=hGmem2
    PrintLibDLG\Flags | #PD_USEDEVMODECOPIESANDCOLLATE
    If PrintLibDLG\nCopies=0
      PrintLibDLG\nCopies=1
    EndIf
    If PrintLibDLG\nFromPage=0
      PrintLibDLG\nFromPage=1
    EndIf
    If PrintLibDLG\nToPage=0
      PrintLibDLG\nToPage=1
    EndIf
    If PrintLibDLG\nMinPage=0
      PrintLibDLG\nMinPage=1
    EndIf
    If PrintLibDLG\nMaxPage=0
      PrintLibDLG\nMaxPage=1
    EndIf
    
    res=PrintDlg_(PrintLibDLG)
    If res<>0
      ;Debug "PrintDlg_ success res="+Str(res)
      *PrinterParameters=GlobalLock_(PrintLibDLG\hDevMode)
      *PrinterNames=GlobalLock_(PrintLibDLG\hDevNames)
      GlobalUnlock_(PrintLibDLG\hDevMode)
      GlobalUnlock_(PrintLibDLG\hDevNames)
      hGmem1=PrintLibDLG\hDevMode
      hGmem2=PrintLibDLG\hDevNames
      If *PrinterNames\wDeviceOffset<>0
        PrintLib_PN=PeekS(*PrinterNames + (*PrinterNames\wDeviceOffset*SizeOf(Character)))
        ;Debug "Buffersize="+Str(Buffersize)
        ;Debug "SizeOf(DEVMODE)="+Str(SizeOf(DEVMODE))
        ;Debug "dmSize="+Str(*PrinterParameters\dmSize)
        ;Debug "dmDriverExtra="+Str(*PrinterParameters\dmDriverExtra)
        ;Debug "GlobalSize_(hGmem1)="+Str(GlobalSize_(hGmem1))
        ;Debug "GlobalSize_(hGmem2)="+Str(GlobalSize_(hGmem2))
        
        ;copy devmode structure to internal buffer
        If *PrintLibDEVMODE
          FreeMemory(*PrintLibDEVMODE)
        EndIf
        *PrintLibDEVMODESize=GlobalSize_(hGmem1)
        *PrintLibDEVMODE=AllocateMemory(*PrintLibDEVMODESize)
        CopyMemory(*PrinterParameters,*PrintLibDEVMODE,*PrintLibDEVMODESize)
        
        ; open the printer and return its DC
        res=ipprint_OpenPrinter(PrintLib_PN,"",0)
      EndIf
      
    EndIf
    
    GlobalFree_(hGmem1)
    GlobalFree_(hGmem2)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_GetPrintDlg()
  ProcedureReturn PrintLibDLG
EndProcedure

Procedure.l ipprint_PrintPrefs(Window.i=0,PrinterName$="")
  Protected hwnd,Buffersize
  
  If IsWindow(Window)
    hwnd=WindowID(Window)
  Else
    hwnd=0
  EndIf
  
  If PrinterName$="" And PrintLib_PN=""
    PrintLib_PN=ipprint_GetDefaultPrinter()
  EndIf
  
  Buffersize=DocumentProperties_(hwnd,PrintLib_PH,PrintLib_PN,0,0,0)
  If Buffersize>0
    If (*PrintLibDEVMODE And *PrintLibDEVMODESize<>Buffersize) Or *PrintLibDEVMODE=0
      If *PrintLibDEVMODE
        FreeMemory(*PrintLibDEVMODE)
      EndIf
      *PrintLibDEVMODE=AllocateMemory(Buffersize)
      *PrintLibDEVMODESize=Buffersize
    EndIf
    
    DocumentProperties_(hwnd,PrintLib_PH,PrintLib_PN,*PrintLibDEVMODE,*PrintLibDEVMODE,#DM_IN_BUFFER|#DM_IN_PROMPT|#DM_OUT_BUFFER)
  EndIf
  
  ProcedureReturn *PrintLibDEVMODE
EndProcedure

Procedure.l ipprint_Plot(x.f,y.f)
  Protected x1,y1,x2,y2
  
  x1=ipprint_ConvertUnitsToPointsX(x)
  y1=ipprint_ConvertUnitsToPointsY(y)
  MoveToEx_(PrintLib_DC,x1,y1,0)
  x2=x1+1
  y2=y1+1
  ProcedureReturn LineTo_(PrintLib_DC,x2,y2)
EndProcedure

Procedure.l ipprint_Line(x1.f,y1.f,x2.f,y2.f)
  Protected x,y,res
  
  ipprint_SaveDebugInfo("ipprint_Line("+StrF(x1)+","+StrF(y1)+","+StrF(x2)+","+StrF(y2)+")")
  ipprint_SetXY(x1,y1)
  x=ipprint_ConvertUnitsToPointsX(x2)
  y=ipprint_ConvertUnitsToPointsY(y2)
  res=LineTo_(PrintLib_DC,x,y)
  ipprint_SaveDebugInfo("LineTo_("+Hex(PrintLib_DC,#PB_Long)+","+Str(x)+","+Str(y)+")="+Hex(res,#PB_Long))
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_LineTo(x.f,y.f)
  x=ipprint_ConvertUnitsToPointsX(x)
  y=ipprint_ConvertUnitsToPointsY(y)
  ProcedureReturn LineTo_(PrintLib_DC,x,y)
EndProcedure

Procedure.l ipprint_CreateBrush(Color.l)
  Protected newbrush
  
  ipprint_SaveDebugInfo("Print_CreateBrush("+Hex(color,#PB_Long)+")")
  ;http://msdn.microsoft.com/library/en-us/gdi/brushes_52y0.asp
  newbrush=CreateSolidBrush_(color)
  ipprint_SaveDebugInfo("CreateSolidBrush_("+Hex(color,#PB_Long)+")="+Hex(newbrush,#PB_Long))
  If newbrush<>0
    DeleteObject_(PrintLib_Brush)
    PrintLib_Brush=newbrush
    SelectObject_(PrintLib_DC,PrintLib_Brush)
  EndIf
  
  ProcedureReturn newbrush
EndProcedure

Procedure.l ipprint_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
  Protected brush.LOGBRUSH,newbrush
  
  ;http://msdn.microsoft.com/library/en-us/gdi/brushes_3lpw.asp
  brush\lbstyle=style
  brush\lbcolor=color
  brush\lbhatch=hatch
  newbrush=CreateBrushIndirect_(brush)
  If newbrush<>0
    DeleteObject_(PrintLib_Brush)
    PrintLib_Brush=newbrush
    SelectObject_(PrintLib_DC,PrintLib_Brush)
  EndIf
  
  ProcedureReturn newbrush
EndProcedure

Procedure.l ipprint_CreateHatchBrush(Style.l,Color.l)
  Protected newbrush
  
  ;http://msdn.microsoft.com/library/en-us/gdi/brushes_8p48.asp
  newbrush=CreateHatchBrush_(style,color)
  If newbrush<>0
    DeleteObject_(PrintLib_Brush)
    PrintLib_Brush=newbrush
    SelectObject_(PrintLib_DC,PrintLib_Brush)
  EndIf
  
  ProcedureReturn newbrush
EndProcedure

Procedure.l ipprint_CreatePatternBrush(hBMP.l)
  Protected newbrush
  
  ;http://msdn.microsoft.com/library/en-us/gdi/brushes_2ilk.asp
  newbrush=CreatePatternBrush_(hbmp)
  If newbrush<>0
    DeleteObject_(PrintLib_Brush)
    PrintLib_Brush=newbrush
    SelectObject_(PrintLib_DC,PrintLib_Brush)
  EndIf
  
  ProcedureReturn newbrush
EndProcedure

Procedure.l ipprint_SetLineWidth(w.f)
  PrintLib_Linewidth=w
  ProcedureReturn ipprint_CreatePen(PrintLib_Linestyle,PrintLib_Linewidth,PrintLib_Linecolor,0,0)
EndProcedure

Procedure.f ipprint_GetLineWidth()
  ProcedureReturn PrintLib_Linewidth
EndProcedure

Procedure.l ipprint_GetLineColor()
  ProcedureReturn PrintLib_Linecolor
EndProcedure

Procedure.l ipprint_SetLineStyle(Style.l)
  ipprint_SaveDebugInfo("Print_SetLineStyle("+Hex(style,#PB_Long)+")")
  PrintLib_Linestyle=style
  ProcedureReturn ipprint_CreatePen(PrintLib_Linestyle,PrintLib_Linewidth,PrintLib_Linecolor,0,0)
EndProcedure

Procedure.l ipprint_GetLineStyle()
  ProcedureReturn PrintLib_Linestyle
EndProcedure

Procedure.l ipprint_FrameRect(x1.f,y1.f,x2.f,y2.f)
  Protected xa,ya,xb,yb,lprc.RECT
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  lprc\left=xa
  lprc\Top=ya
  lprc\right=xb
  lprc\bottom=yb
  ProcedureReturn FrameRect_(PrintLib_DC,lprc,PrintLib_Brush)
EndProcedure

Procedure.l ipprint_FillRect(x1.f,y1.f,x2.f,y2.f)
  Protected xa,ya,xb,yb,lprc.RECT
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  lprc\left=xa
  lprc\Top=ya
  lprc\right=xb
  lprc\bottom=yb
  ProcedureReturn FillRect_(PrintLib_DC,lprc,PrintLib_Brush)
EndProcedure

Procedure.l ipprint_InvertRect(x1.f,y1.f,x2.f,y2.f)
  Protected xa,ya,xb,yb,lprc.RECT
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  lprc\left=xa
  lprc\Top=ya
  lprc\right=xb
  lprc\bottom=yb
  ProcedureReturn InvertRect_(PrintLib_DC,lprc)
EndProcedure

Procedure.l ipprint_GetTextAlign()
  Protected TA
  
  ;TA=1 is the default after GetTextAlign_(hDC) 
  TA=GetTextAlign_(PrintLib_DC)
  Select TA & 6
    Case #TA_CENTER ; 6
      Debug "#TA_CENTER"
    Case #TA_RIGHT ; 2
      Debug "#TA_RIGHT"
    Default ; 0
      Debug "#TA_LEFT"
  EndSelect
  
  Select TA & 24
    Case #TA_BOTTOM ; 8
      Debug "#TA_BOTTOM"
    Case #TA_BASELINE ; 24
      Debug "#TA_BASELINE"
    Default ; 0
      Debug "#TA_TOP"
  EndSelect
  
  Select TA & 1
    Case #TA_UPDATECP
      Debug "#TA_UPDATECP"
    Default ; 0
      Debug "#TA_NOUPDATECP"
  EndSelect
  
  Select TA & 256
    Case 256 ; #TA_RTLREADING
      Debug "#TA_RTLREADING"
  EndSelect
  
  ProcedureReturn TA
EndProcedure

Procedure.f ipprint_SetTextSpacing(l.f)
  Protected x,oldx
  
  x=ipprint_ConvertUnitsToPointsX(l)
  oldx=SetTextCharacterExtra_(PrintLib_DC,x)
  ProcedureReturn ipprint_ConvertPointsToUnitsX(oldx)
EndProcedure

Procedure.l ipprint_SetTextJustification(l.f,Count.l)
  Protected x
  
  x=ipprint_ConvertUnitsToPointsX(l)
  ProcedureReturn SetTextJustification_(PrintLib_DC,x,Count)
EndProcedure

Procedure.l ipprint_SetArcDirection(arcd.l)
  ProcedureReturn SetArcDirection_(PrintLib_DC,arcd)
EndProcedure

Procedure.l ipprint_GetArcDirection()
  ProcedureReturn GetArcDirection_(PrintLib_DC)
EndProcedure

Procedure.l ipprint_Arc(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f)
  Protected xa,ya,xb,yb,xc,yc,xd,yd
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  xc=ipprint_ConvertUnitsToPointsX(x3)
  yc=ipprint_ConvertUnitsToPointsY(y3)
  xd=ipprint_ConvertUnitsToPointsX(x4)
  yd=ipprint_ConvertUnitsToPointsY(y4)
  ProcedureReturn Arc_(PrintLib_DC,xa,ya,xb,yb,xc,yc,xd,yd)
EndProcedure

Procedure.l ipprint_AngleArc(x.f,y.f,r.f,Startangle.l,Sweepangle.l)
  Protected xa,ya,ra
  
  xa=ipprint_ConvertUnitsToPointsX(x)
  ya=ipprint_ConvertUnitsToPointsX(y)
  ra=ipprint_ConvertUnitsToPointsX(r)
  ProcedureReturn AngleArc_(PrintLib_DC,xa,ya,ra,startangle,sweepangle)
EndProcedure

Import "Msimg32.lib"
  GradientFill(hDC,*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
EndImport

Procedure.l ipprint_GradientFill(*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
  ProcedureReturn GradientFill(PrintLib_DC,*Vertex,NumVertex,*Mesh,NumMesh,Mode)
EndProcedure

Procedure.f ipprint_DrawText(x.f,y.f,w.f,h.f,Text$,Format.l=0,*RX=0,*RY=0,*RW=0,*RH=0)
  Protected l,lprect.RECT
  
  l=Len(text$)
  lprect\Left   = ipprint_ConvertUnitsToPointsX(x)
  lprect\Top    = ipprint_ConvertUnitsToPointsY(y)
  lprect\Right  = ipprint_ConvertUnitsToPointsX(x+w)
  lprect\Bottom = ipprint_ConvertUnitsToPointsY(y+h)
  h=DrawText_(PrintLib_DC,@text$,l,lprect,format)
  If *RX<>0
    PokeF(*RX,ipprint_ConvertPointsToUnitsX(lprect\Left))
  EndIf
  If *RY<>0
    PokeF(*RY,ipprint_ConvertPointsToUnitsY(lprect\Top))
  EndIf
  If *RW<>0
    PokeF(*RW,ipprint_ConvertPointsToUnitsX(lprect\Right-lprect\Left))
  EndIf
  If *RH<>0
    PokeF(*RH,ipprint_ConvertPointsToUnitsY(lprect\Bottom-lprect\Top))
  EndIf
  ProcedureReturn ipprint_ConvertPointsToUnitsY(h)
EndProcedure

Procedure.l ipprint_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l=#False)
  Protected brush.LOGBRUSH,newbrush,oldbrush,xa,ya,xb,yb,res
  
  If fill=#False
    brush\lbstyle=#BS_HOLLOW
    brush\lbcolor=0
    brush\lbhatch=0
    newbrush=CreateBrushIndirect_(brush)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
  EndIf
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  
  res=Ellipse_(PrintLib_DC,xa,ya,xb,yb)
  
  If newbrush<>0
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_Chord(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l=#False)
  Protected brush.LOGBRUSH,newbrush,oldbrush,xa,ya,xb,yb,xc,yc,xd,yd,res
  
  If fill=#False
    brush\lbstyle=#BS_HOLLOW
    brush\lbcolor=0
    brush\lbhatch=0
    newbrush=CreateBrushIndirect_(brush)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
  EndIf
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  xc=ipprint_ConvertUnitsToPointsX(x3)
  yc=ipprint_ConvertUnitsToPointsY(y3)
  xd=ipprint_ConvertUnitsToPointsX(x4)
  yd=ipprint_ConvertUnitsToPointsY(y4)
  
  res=Chord_(PrintLib_DC,xa,ya,xb,yb,xc,yc,xd,yd)
  
  If newbrush<>0
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_Pie(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l=#False)
  Protected brush.LOGBRUSH,newbrush,oldbrush,xa,ya,xb,yb,xc,yc,xd,yd,res
  
  If fill=#False
    brush\lbstyle=#BS_HOLLOW
    brush\lbcolor=0
    brush\lbhatch=0
    newbrush=CreateBrushIndirect_(brush)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
  EndIf
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  xc=ipprint_ConvertUnitsToPointsX(x3)
  yc=ipprint_ConvertUnitsToPointsY(y3)
  xd=ipprint_ConvertUnitsToPointsX(x4)
  yd=ipprint_ConvertUnitsToPointsY(y4)
  
  res=Pie_(PrintLib_DC,xa,ya,xb,yb,xc,yc,xd,yd)
  
  If newbrush<>0
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_Rectangle(x1.f,y1.f,x2.f,y2.f,Fill.l=#False)
  Protected brush.LOGBRUSH,newbrush,oldbrush,xa,ya,xb,yb,res
  
  ipprint_SaveDebugInfo("ipprint_Rectangle("+StrF(x1)+","+StrF(y1)+","+StrF(x2)+","+StrF(y2)+","+Str(fill)+")")
  
  If fill=#False
    brush\lbstyle=#BS_HOLLOW
    brush\lbcolor=0
    brush\lbhatch=0
    newbrush=CreateBrushIndirect_(brush)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
  EndIf
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  
  res=Rectangle_(PrintLib_DC,xa,ya,xb,yb)
  ipprint_SaveDebugInfo("Rectangle_("+Hex(PrintLib_DC,#PB_Long)+","+Str(xa)+","+Str(ya)+","+Str(xb)+","+Str(yb)+")="+Str(res))
  
  If newbrush<>0
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_RoundRect(x1.f,y1.f,x2.f,y2.f,w.f,h.f,Fill.l=#False)
  Protected brush.LOGBRUSH,newbrush,oldbrush,xa,ya,xb,yb,wa,ha,res
  
  If fill=#False
    brush\lbstyle=#BS_HOLLOW
    brush\lbcolor=0
    brush\lbhatch=0
    newbrush=CreateBrushIndirect_(brush)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
  EndIf
  
  xa=ipprint_ConvertUnitsToPointsX(x1)
  ya=ipprint_ConvertUnitsToPointsY(y1)
  xb=ipprint_ConvertUnitsToPointsX(x2)
  yb=ipprint_ConvertUnitsToPointsY(y2)
  wa=ipprint_ConvertUnitsToPointsX(w)
  ha=ipprint_ConvertUnitsToPointsY(h)
  
  res=RoundRect_(PrintLib_DC,xa,ya,xb,yb,wa,ha)
  
  If newbrush<>0
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.f ipprint_GetX()
  Protected res.f,pos.POINT
  
  If GetCurrentPositionEx_(PrintLib_DC,pos)
    res=ipprint_ConvertPointsToUnitsX(pos\x)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.f ipprint_GetY()
  Protected res.f,pos.POINT
  
  If GetCurrentPositionEx_(PrintLib_DC,pos)
    res.f=ipprint_ConvertPointsToUnitsY(pos\y)
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_SetXY(x.f,y.f)
  Protected xa,ya
  
  xa=ipprint_ConvertUnitsToPointsX(x)
  ya=ipprint_ConvertUnitsToPointsY(y)
  ProcedureReturn MoveToEx_(PrintLib_DC,xa,ya,0)
EndProcedure

Procedure.l ipprint_SetX(x.f)
  Protected pos.POINT,res=#False,xa
  
  xa=ipprint_ConvertUnitsToPointsX(x)
  
  If GetCurrentPositionEx_(PrintLib_DC,pos)
    pos\x=xa
    If MoveToEx_(PrintLib_DC,pos\x,pos\y,0)
      res=#True
    EndIf
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_SetY(y.f)
  Protected pos.POINT,res=#False,ya
  
  ya=ipprint_ConvertUnitsToPointsY(y)
  
  If GetCurrentPositionEx_(PrintLib_DC,pos)
    pos\y=ya
    If MoveToEx_(PrintLib_DC,pos\x,pos\y,0)
      res=#True
    EndIf
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure ipprint_SetDebug(Mode.l)
  If mode
    PrintLib_Debug=#True
  Else
    PrintLib_Debug=#False
  EndIf
EndProcedure

Procedure.l ipprint_Image(Imagenr.l,x.f,y.f,w.f=0,h.f=0,Mode.l=#SRCCOPY)
  Protected res,Imageid,xa,ya,nw,nh,devcap,devtechnology,cap$,technology$,wa,ha,bits,hdc,hBmp,bmi.BITMAPINFO,mem,newimg
  
  If w=0
    w=ipprint_ConvertPointsToUnitsX(ImageWidth(Imagenr))
  EndIf
  If h=0
    h=ipprint_ConvertPointsToUnitsY(ImageHeight(Imagenr))
  EndIf
  ipprint_SaveDebugInfo("ipprint_Image("+Hex(Imagenr,#PB_Long)+","+StrF(x)+","+StrF(y)+","+StrF(w)+","+Str(h)+","+Hex(mode,#PB_Long)+")")
  
  res=IsImage(Imagenr)
  ipprint_SaveDebugInfo("IsImage("+Hex(Imagenr,#PB_Long)+")="+Hex(res,#PB_Long))
  
  If res=0
    ProcedureReturn
  EndIf
  
  Imageid=ImageID(Imagenr)
  ipprint_SaveDebugInfo("UseImage("+Str(Imagenr)+")="+Str(Imageid))
  
  If mode=0
    mode=#SRCCOPY
  EndIf
  res=0
  
  xa=ipprint_ConvertUnitsToPointsX(x)
  ya=ipprint_ConvertUnitsToPointsY(y)
  
  nw=ipprint_ConvertUnitsToPointsX(w);(wa*wp)/100
  nh=ipprint_ConvertUnitsToPointsY(h);(ha*hp)/100
  
  devcap=GetDeviceCaps_(PrintLib_DC,#RASTERCAPS)
  If devcap & #RC_BANDING
    cap$+",#RC_BANDING"
  EndIf
  If devcap & #RC_BITBLT
    cap$+",#RC_BITBLT"
  EndIf
  If devcap & #RC_BITMAP64
    cap$+",#RC_BITMAP64"
  EndIf
  If devcap & #RC_DI_BITMAP
    cap$+",#RC_DI_BITMAP"
  EndIf
  If devcap & #RC_DIBTODEV
    cap$+",#RC_DIBTODEV"
  EndIf
  If devcap & #RC_FLOODFILL
    cap$+",#RC_FLOODFILL"
  EndIf
  If devcap & #RC_PALETTE
    cap$+",#RC_PALETTE"
  EndIf
  If devcap & #RC_SCALING
    cap$+",#RC_SCALING"
  EndIf
  If devcap & #RC_STRETCHBLT
    cap$+",#RC_STRETCHBLT"
  EndIf
  If devcap & #RC_STRETCHDIB
    cap$+",#RC_STRETCHDIB"
  EndIf
  ipprint_SaveDebugInfo("GetDeviceCaps_("+Hex(PrintLib_DC,#PB_Long)+",#RASTERCAPS)="+Right(cap$,Len(cap$)-1))
  devtechnology=GetDeviceCaps_(PrintLib_DC,#TECHNOLOGY)
  If devtechnology & #DT_PLOTTER ; Vector plotter
    technology$+",#DT_PLOTTER"
  EndIf
  If devtechnology & #DT_RASDISPLAY ; Raster display
    technology$+",#DT_RASDISPLAY"
  EndIf
  If devtechnology & #DT_RASPRINTER ; Raster printer
    technology$+",#DT_RASPRINTER"
  EndIf
  If devtechnology & #DT_RASCAMERA ; Raster camera
    technology$+",#DT_RASCAMERA"
  EndIf
  If devtechnology & #DT_CHARSTREAM ; Character stream
    technology$+",#DT_CHARSTREAM"
  EndIf
  If devtechnology & #DT_METAFILE ; Metafile
    technology$+",#DT_METAFILE"
  EndIf
  If devtechnology & #DT_DISPFILE ; Display file
    technology$+",#DT_DISPFILE"
  EndIf
  ipprint_SaveDebugInfo("GetDeviceCaps_("+Hex(PrintLib_DC,#PB_Long)+",#TECHNOLOGY)="+Right(technology$,Len(technology$)-1))
  
  wa=ImageWidth(Imagenr) ; x
  ha=ImageHeight(Imagenr) ; y
  bits=ImageDepth(Imagenr)
  ipprint_SaveDebugInfo("ImageWidth="+Str(wa))
  ipprint_SaveDebugInfo("ImageHeight="+Str(ha))
  ipprint_SaveDebugInfo("ImageDepth="+Str(bits))
  
  If devcap & #RC_STRETCHBLT
    ipprint_SaveDebugInfo("Using #RC_STRETCHBLT method")
    hdc=CreateCompatibleDC_(0)
    ipprint_SaveDebugInfo("CreateCompatibleDC_(0)="+Str(hdc))
    If hdc
      res=SelectObject_(hdc,Imageid)
      ipprint_SaveDebugInfo("SelectObject_("+Str(hdc)+","+Str(Imageid)+")="+Str(res))
      If res
        res=StretchBlt_(PrintLib_DC,xa,ya,nw,nh,hdc,0,0,wa,ha,mode)
        ipprint_SaveDebugInfo("StretchBlt_("+Hex(PrintLib_DC,#PB_Long)+","+Str(xa)+","+Str(ya)+","+Str(nw)+","+Str(nh)+","+Str(hdc)+",0,0,"+Str(wa)+","+Str(ha)+","+Str(mode)+")="+Str(res))
      EndIf
      DeleteDC_(hdc)
    EndIf
  ElseIf devcap & (#RC_DI_BITMAP|#RC_STRETCHDIB)
    ipprint_SaveDebugInfo("Using #RC_STRETCHDIB method")
    hBmp=ImageID(imagenr)
    mem=AllocateMemory(wa*ha*4)
    bmi\bmiHeader\biSize        = SizeOf(BITMAPINFOHEADER) 
    bmi\bmiHeader\biWidth       =  wa 
    bmi\bmiHeader\biHeight      = -ha
    bmi\bmiHeader\biPlanes      =  1 
    bmi\bmiHeader\biBitCount    = 24 
    bmi\bmiHeader\biCompression = #BI_RGB
    hdc=StartDrawing(ImageOutput(imagenr))
    If hdc
      ipprint_SaveDebugInfo("StartDrawing(ImageOutput())="+Str(hdc))
      res=GetDIBits_(hDC,hBmp,0,ha,mem,bmi,#DIB_RGB_COLORS)
      ipprint_SaveDebugInfo("GetDIBits_("+Str(hDc)+","+Str(hBmp)+",0,"+Str(ha)+","+Str(mem)+","+Str(bmi)+","+Str(#DIB_RGB_COLORS)+")="+Str(res))
      StopDrawing()
      If res
        res=StretchDIBits_(PrintLib_DC,xa,ya,nw,nh,0,0,wa,ha,mem,bmi,#DIB_RGB_COLORS,mode)
        ipprint_SaveDebugInfo("StretchDIBits_("+Str(PrintLib_DC)+","+Str(xa)+","+Str(ya)+","+Str(nw)+","+Str(nh)+",0,0,"+Str(wa)+","+Str(ha)+","+Str(mem)+","+Str(bmi)+","+Str(#DIB_RGB_COLORS)+","+Str(mode)+")="+Str(res))
      EndIf
    EndIf
  ElseIf devcap & #RC_BITBLT
    ipprint_SaveDebugInfo("Using #RC_BITBLT method")
    newimg=CopyImage(imagenr,#PB_Any)
    ipprint_SaveDebugInfo("CopyImage("+Str(imagenr)+","+Str(#PB_Any)+")="+Str(newimg))
    imageid=ResizeImage(newimg,nw,nh)
    imageid=ImageID(newimg)
    ipprint_SaveDebugInfo("ResizeImage("+Str(newimg)+","+Str(nw)+","+Str(nh)+")="+Str(imageid))
    
    wa=ImageWidth(newimg) ; x
    ha=ImageHeight(newimg) ; y
    bits=ImageDepth(newimg)
    ipprint_SaveDebugInfo("ImageWidth="+Str(wa))
    ipprint_SaveDebugInfo("ImageHeight="+Str(ha))
    ipprint_SaveDebugInfo("ImageDepth="+Str(bits))
    
    hdc=CreateCompatibleDC_(0)
    ipprint_SaveDebugInfo("CreateCompatibleDC_(0)="+Str(hdc))
    If hdc
      res=SelectObject_(hdc,imageid)
      ipprint_SaveDebugInfo("SelectObject_("+Str(hdc)+","+Str(imageid)+")="+Str(res))
      If res
        res=BitBlt_(PrintLib_DC,xa,ya,wa,ha,hdc,0,0,mode)
        ipprint_SaveDebugInfo("BitBlt_("+Str(PrintLib_DC)+","+Str(xa)+","+Str(ya)+","+Str(wa)+","+Str(ha)+","+Str(hdc)+",0,0,"+Str(mode)+")="+Str(res))
      EndIf
      DeleteDC_(hdc)
    EndIf
    If IsImage(imageid)
      FreeImage(newimg)
    EndIf
  EndIf
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_StartDocPrinter(Jobname$,OutputFileName$="",Datatype$="RAW")
  Protected PDoc.DOC_INFO_1,jobid
  
  If Jobname$<>""
    PDoc\pDocName=@Jobname$
  EndIf
  If OutputFileName$<>""
    PDoc\pOutputFile=@OutputFileName$
  EndIf
  If Datatype$<>""
    PDoc\pDatatype=@Datatype$
  EndIf
  jobid=StartDocPrinter_(PrintLib_PH,1,PDoc)
  If StartPagePrinter_(PrintLib_PH)
    ProcedureReturn jobid
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.l ipprint_EndDocPrinter()
  Protected res=#False
  
  EndPagePrinter_(PrintLib_PH)
  If EndDocPrinter_(PrintLib_PH)
    res=#True
  EndIf
  
  ipprint_End()
  
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_WriteData(*Membuffer,Size.l)
  Protected Byteswritten
  
  If WritePrinter_(PrintLib_PH,*Membuffer,Size,@Byteswritten)
    ipprint_SaveDebugInfo("WritePrinter_(PrintLib_PH="+Str(PrintLib_PH)+",*Membuffer="+Str(*Membuffer)+",Size="+Str(Size)+")")
    ProcedureReturn Byteswritten
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.l ipprint_WriteString(String$,Mode=#PB_Ascii)
  Protected Res=0,Size,*Mem
  
  Size=StringByteLength(String$,Mode)
  *Mem=AllocateMemory(Size+2) ; reserve more space for the terminating zero character !
  If *Mem
    PokeS(*Mem,String$,-1,Mode)
    Res=ipprint_WriteData(*Mem,Size)
    FreeMemory(*Mem)
  EndIf
  
  ProcedureReturn Res
EndProcedure

Procedure.s ipprint_GetLastError(err.l=0)
  Protected buffer,ferr,errormsg$
  
  If err=0
    err=GetLastError_()
  EndIf
  ferr=FormatMessage_(#FORMAT_MESSAGE_ALLOCATE_BUFFER|#FORMAT_MESSAGE_FROM_SYSTEM,0,err,GetUserDefaultLangID_(),@buffer,0,0)
  If buffer<>0
    errormsg$=PeekS(buffer)
    LocalFree_(buffer)
    errormsg$=RemoveString(errormsg$,Chr(13)+Chr(10))
    ProcedureReturn errormsg$
  EndIf
EndProcedure

Procedure.l ipprint_StartPreview(x.l)
  Protected x1,y1,dpix,dpiy,newbrush,oldbrush,lprc.RECT
  
  ipprint_SaveDebugInfo("Print_StartPreview("+Str(x)+")")
  
  PrintLib_oldDC=PrintLib_DC
  
  ForEach PrintLib_Images()
    FreeImage(PrintLib_Images())
  Next
  
  ClearList(PrintLib_Images())
  
  x1=GetDeviceCaps_(PrintLib_oldDC,#HORZRES)
  y1=GetDeviceCaps_(PrintLib_oldDC,#VERTRES)
  dpix=GetDeviceCaps_(PrintLib_oldDC,#LOGPIXELSX)
  dpiy=GetDeviceCaps_(PrintLib_oldDC,#LOGPIXELSY)
  If x1 And x1 And dpix And dpiy
    PrintLib_PreviewX=x
    PrintLib_PreviewY=((x*y1)/x1)*(dpix/dpiy)
    AddElement(PrintLib_Images())
    PrintLib_Images()=CreateImage(#PB_Any,PrintLib_PreviewX,PrintLib_PreviewY,24)
    PrintLib_DC=StartDrawing(ImageOutput(PrintLib_Images()))
  Else
    PrintLib_DC=0
  EndIf
  
  If PrintLib_DC<>0
    ; Fill background with white
    newbrush=CreateSolidBrush_(#White)
    oldbrush=SelectObject_(PrintLib_DC,newbrush)
    lprc\left=0
    lprc\Top=0
    lprc\right=PrintLib_PreviewX
    lprc\bottom=PrintLib_PreviewY
    FillRect_(PrintLib_DC,lprc,newbrush)
    SelectObject_(PrintLib_DC,oldbrush)
    DeleteObject_(newbrush)
    PrintLib_Preview=#True
    ipprint_Standardsettings()
    ProcedureReturn PrintLib_DC
  Else
    PrintLib_DC=PrintLib_oldDC
    PrintLib_Preview=#False
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.l ipprint_StopPreview()
  If PrintLib_Preview=#True
    PrintLib_Preview=#False
    ipprint_SaveDebugInfo("Print_StopPreview()")
    StopDrawing()
    PrintLib_DC=PrintLib_oldDC
    ProcedureReturn PrintLib_DC
  EndIf
EndProcedure

Procedure.l ipprint_GetPreviewImage(Index.l)
  Protected count
  
  count=ListSize(PrintLib_Images())
  If count>0 And (Index=<(count-1))
    SelectElement(PrintLib_Images(),Index)
    ProcedureReturn PrintLib_Images()
  Else
    ProcedureReturn 0
  EndIf
EndProcedure

Procedure.l ipprint_SetPrinter(Level.l,*pPrinter,Command.l)
  ;http://msdn.microsoft.com/library/en-us/gdi/prntspol_13ua.asp
  ProcedureReturn SetPrinter_(PrintLib_PH,Level,*pPrinter,Command)
EndProcedure

Procedure.l ipprint_GetPrinter(Level.l,*pPrinter,cbBuf.l,pcbNeeded.l)
  ;http://msdn.microsoft.com/library/en-us/gdi/prntspol_1gky.asp
  ProcedureReturn GetPrinter_(PrintLib_PH,Level,*pPrinter,cbBuf,pcbNeeded)
EndProcedure

Procedure.l ipprint_SetStatus(Status.l)
  Protected attr,*pinfo,cbBuf,res,pcbneeded,*info2.PRINTER_INFO_2
  
  If ipprint_GetPrinter(2,*pinfo,0,@cbBuf)=0 And GetLastError_()=#ERROR_INSUFFICIENT_BUFFER
    If cbBuf<>0
      *pinfo=AllocateMemory(cbBuf)
      If *pinfo>0
        If ipprint_GetPrinter(2,*pinfo,cbBuf,@pcbneeded)
          *info2=*pinfo
          Select status
            Case #PRINTER_CONTROL_PAUSE
              res=ipprint_SetPrinter(0,0,#PRINTER_CONTROL_PAUSE)
            Case #PRINTER_CONTROL_PURGE
              res=ipprint_SetPrinter(0,0,#PRINTER_CONTROL_PURGE)
            Case #PRINTER_CONTROL_RESUME
              res=ipprint_SetPrinter(0,0,#PRINTER_CONTROL_RESUME)
          EndSelect
        EndIf
        FreeMemory(*pinfo)
      EndIf
    EndIf
  EndIf
  ProcedureReturn res
EndProcedure

Procedure.l ipprint_GetStatus(Type.l)
  Protected status,attr,*pinfo,cbBuf,*info2.PRINTER_INFO_2,pcbneeded
  
  If ipprint_GetPrinter(2,*pinfo,0,@cbBuf)=0 And GetLastError_()=#ERROR_INSUFFICIENT_BUFFER
    If cbBuf<>0
      *pinfo=AllocateMemory(cbBuf)
      If *pinfo>0
        If ipprint_GetPrinter(2,*pinfo,cbBuf,@pcbneeded)
          *info2=*pinfo
          attr=*info2\Attributes
          status=*info2\Status
          ;MessageRequester("",Str(attr)+" "+Str(status),0)
        EndIf
        FreeMemory(*pinfo)
      EndIf
    EndIf
  EndIf
  
  Select type
    Case #PRINT_ATTRIBUTES
      ProcedureReturn attr
    Case #PRINT_STATUS
      ProcedureReturn status
  EndSelect
EndProcedure

Procedure.l ipprint_EnumPrinters(enum.l=#PRINTER_ENUM_LOCAL|#PRINTER_ENUM_CONNECTIONS) ; Enumerates all Printers
  Protected buf,cnt,mem,bytes,cntret,size,i
  
  ClearList(Print_Printers())
  
  If EnumPrinters_(enum,0,1,0,0,@buf,@cnt)=0
    mem=AllocateMemory(buf)
    If mem And EnumPrinters_(enum,0,1,mem,buf,@bytes,@cntret)
      size=SizeOf(PRINTER_INFO_1)
      If cntret
        For i=0 To cntret-1
          AddElement(Print_Printers())
          Print_Printers()=PeekS(PeekL(mem+i*size+ 8))
        Next
      EndIf
      FreeMemory(mem)
      ProcedureReturn 1
    EndIf
  EndIf
EndProcedure

Procedure.s ipprint_EnumPrinterName(Index.l) ; Get the name of the printer, index begins at 0
  Protected count
  
  count=ListSize(Print_Printers())
  If count>0 And (Index=<(count-1))
    SelectElement(Print_Printers(),Index)
    ProcedureReturn Print_Printers()
  EndIf
EndProcedure

Procedure.l ipprint_EnumFontsExProc(*lpelfe.ENUMLOGFONTEX,*lpntme,FontType.l,lParam.l)
  AddElement(Print_Fonts())
  Print_Fonts()\ID=ListSize(Print_Fonts())
  Print_Fonts()\Name=PeekS(@*lpelfe\elfFullName,64)
  Print_Fonts()\Style=PeekS(@*lpelfe\elfStyle,32)
  Print_Fonts()\Script=PeekS(@*lpelfe\elfScript,32)
  ProcedureReturn 1 ; 1=continue enumeration / 0=stop enumeration
EndProcedure

Procedure.l ipprint_EnumFontsProc(*lpelfe.ENUMLOGFONT,*lpntme,FontType.l,lParam.l)
  AddElement(Print_Fonts())
  Print_Fonts()\ID=ListSize(Print_Fonts())
  Print_Fonts()\Name=PeekS(@*lpelfe\elfFullName,64)
  Print_Fonts()\Style=PeekS(@*lpelfe\elfStyle,32)
  ProcedureReturn 1 ; 1=continue enumeration / 0=stop enumeration
EndProcedure

Procedure.l ipprint_EnumFonts(CharSet.l=#DEFAULT_CHARSET,PitchAndFamily.l=0,Name.s="")
  Protected Font.LOGFONT
  
  Font\lfCharset=CharSet & $FF
  If Name<>""
    If Len(Name)<#LF_FACESIZE
      CopyMemory(@Name,@Font\lfFaceName,Len(Name))
    Else
      CopyMemory(@Name,@Font\lfFaceName,#LF_FACESIZE)
    EndIf
  EndIf
  Font\lfPitchAndFamily=PitchAndFamily & $FF
  
  ClearList(Print_Fonts())
  
  CompilerIf 1 ; Method 1 = EnumFontFamiliesEx_
    EnumFontFamiliesEx_(PrintLib_DC,Font,@ipprint_EnumFontsExProc(),0,0)
  CompilerElse ; Method 2 = EnumFontFamilies_
    If Name=""
      EnumFontFamilies_(PrintLib_DC,0,@ipprint_EnumFontsProc(),0)
    Else
      EnumFontFamilies_(PrintLib_DC,@Name,@ipprint_EnumFontsProc(),0)
    EndIf
  CompilerEndIf
  
  ;SortStructuredList(Print_Fonts(),0,OffsetOf(PrintLib_Fonts\Name),#PB_Sort_String)
  
  ProcedureReturn #True
EndProcedure

Procedure.l ipprint_EnumFontID(Index.l)
  Protected count
  
  count=ListSize(Print_Fonts())
  If count>0 And (Index=<(count-1))
    SelectElement(Print_Fonts(),Index)
    ProcedureReturn Print_Fonts()\ID
  EndIf
EndProcedure

Procedure.s ipprint_EnumFontName(Index.l)
  Protected count
  
  count=ListSize(Print_Fonts())
  If count>0 And (Index=<(count-1))
    SelectElement(Print_Fonts(),Index)
    ProcedureReturn Print_Fonts()\Name
  EndIf
EndProcedure

Procedure.s ipprint_EnumFontStyle(Index.l)
  Protected count
  
  count=ListSize(Print_Fonts())
  If count>0 And (Index=<(count-1))
    SelectElement(Print_Fonts(),Index)
    ProcedureReturn Print_Fonts()\Style
  EndIf
EndProcedure

Procedure.s ipprint_EnumFontScript(Index.l)
  Protected count
  
  count=ListSize(Print_Fonts())
  If count>0 And (Index=<(count-1))
    SelectElement(Print_Fonts(),Index)
    ProcedureReturn Print_Fonts()\Script
  EndIf
EndProcedure

CompilerIf Defined(PrinterLib_Include,#PB_Constant) ;{ as Include
  ipprint_Init()
  
  Procedure Print_About()
    MessageRequester("Printer_Lib","Written by Klaus Dresen",0)
  EndProcedure
  Procedure.l Print_AdvancedProperties(Window.i)
    ProcedureReturn ipprint_AdvancedProperties(Window.i)
  EndProcedure
  Procedure.l Print_AngleArc(x.f,y.f,r.f,Startangle.l,Sweepangle.l)
    ProcedureReturn ipprint_AngleArc(x,y,r,Startangle,Sweepangle)
  EndProcedure
  Procedure.l Print_Arc(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f)
    ProcedureReturn ipprint_Arc(x1,y1,x2,y2,x3,y3,x4,y4)
  EndProcedure
  Procedure.l Print_Box(x.f,y.f,w.f,h.f,Fill.l=#False)
    ProcedureReturn ipprint_Rectangle(x,y,x+w,y+h,Fill)
  EndProcedure
  Procedure.l Print_Chord(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l=#False)
    ProcedureReturn ipprint_Chord(x1,y1,x2,y2,x3,y3,x4,y4,Fill)
  EndProcedure
  Procedure.l Print_Circle(x.f,y.f,r.f,Fill.l=#False)
    ProcedureReturn ipprint_Ellipse(x-r,y-r,x+r,y+r,Fill)
  EndProcedure
  Procedure.l Print_ConvertUnitsToPointsX(x.f)
    ProcedureReturn ipprint_ConvertUnitsToPointsX(x.f)
  EndProcedure
  Procedure.l Print_ConvertUnitsToPointsY(y.f)
    ProcedureReturn ipprint_ConvertUnitsToPointsY(y.f)
  EndProcedure
  Procedure.f Print_ConvertPointsToUnitsX(x.l)
    ProcedureReturn ipprint_ConvertPointsToUnitsX(x.l)
  EndProcedure
  Procedure.f Print_ConvertPointsToUnitsY(y.l)
    ProcedureReturn ipprint_ConvertPointsToUnitsY(y.l)
  EndProcedure
  Procedure.l Print_CountFonts()
    ProcedureReturn ListSize(Print_Fonts())
  EndProcedure
  Procedure.l Print_CountPrinters()
    ProcedureReturn ListSize(Print_Printers())
  EndProcedure
  Procedure.l Print_CreateBrush(Color.l)
    ProcedureReturn ipprint_CreateBrush(Color)
  EndProcedure
  Procedure.l Print_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
    ProcedureReturn ipprint_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
  EndProcedure
  Procedure.l Print_CreateHatchBrush(Style.l,Color.l)
    ProcedureReturn ipprint_CreateHatchBrush(Style.l,Color.l)
  EndProcedure
  Procedure.l Print_CreatePatternBrush(hBMP.l)
    ProcedureReturn ipprint_CreatePatternBrush(hBMP.l)
  EndProcedure
  Procedure.l Print_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style)
    ProcedureReturn ipprint_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style)
  EndProcedure
  Procedure.f Print_DrawText(x.f,y.f,w.f,h.f,Text$,Format.l=0,*RX=0,*RY=0,*RW=0,*RH=0)
    ProcedureReturn ipprint_DrawText(x.f,y.f,w.f,h.f,Text$,Format,*RX,*RY,*RW,*RH)
  EndProcedure
  Procedure.l Print_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l=#False)
    ProcedureReturn ipprint_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l)
  EndProcedure
  Procedure Print_End()
    ipprint_End()
  EndProcedure
  Procedure.l Print_EndDocPrinter()
    ProcedureReturn ipprint_EndDocPrinter()
  EndProcedure
  Procedure.l Print_EndPagePrinter()
    ProcedureReturn EndPagePrinter_(PrintLib_PH)
  EndProcedure
  Procedure.l Print_EnumFontID(Index.l)
    ProcedureReturn ipprint_EnumFontID(Index)
  EndProcedure
  Procedure.l Print_EnumFonts(CharSet.b=#DEFAULT_CHARSET,Name.s="")
    ProcedureReturn ipprint_EnumFonts(CharSet,0,Name)
  EndProcedure
  Procedure.l Print_EnumPrinters(enum.l=#PRINTER_ENUM_LOCAL|#PRINTER_ENUM_CONNECTIONS)
    ProcedureReturn ipprint_EnumPrinters(enum)
  EndProcedure
  Procedure.l Print_FillRect(x1.f,y1.f,x2.f,y2.f)
    ProcedureReturn ipprint_FillRect(x1,y1,x2,y2)
  EndProcedure
  Procedure.l Print_Font(Font$,Height.l,Flags.l=0,Rotate.l=0)
    ProcedureReturn ipprint_Font(Font$,Height,Flags,Rotate)
  EndProcedure
  Procedure.l Print_FrameRect(x1.f,y1.f,x2.f,y2.f)
    ProcedureReturn ipprint_FrameRect(x1,y1,x2,y2)
  EndProcedure
  Procedure.l Print_GetArcDirection()
    ProcedureReturn ipprint_GetArcDirection()
  EndProcedure
  Procedure.l Print_GetDeviceCaps(Type.l)
    ProcedureReturn ipprint_GetDeviceCaps(Type.l)
  EndProcedure
  Procedure.l Print_GetFontFlags()
    ProcedureReturn PrintLib_FontFlags
  EndProcedure
  Procedure.l Print_GetFontHeight()
    ProcedureReturn PrintLib_FontHeight
  EndProcedure
  Procedure.l Print_GetFontRotate()
    ProcedureReturn PrintLib_FontRotate
  EndProcedure
  Procedure.l Print_GetLineColor()
    ProcedureReturn ipprint_GetLineColor()
  EndProcedure
  Procedure.l Print_GetLineStyle()
    ProcedureReturn ipprint_GetLineStyle()
  EndProcedure
  Procedure.f Print_GetLineWidth()
    ProcedureReturn ipprint_GetLineWidth()
  EndProcedure
  Procedure.f Print_GetOutlineTextMetrics(Type.l)
    ProcedureReturn ipprint_GetOutlineTextMetrics(Type.l)
  EndProcedure
  Procedure.l Print_GetPreviewCount()
    ProcedureReturn ListSize(PrintLib_Images())
  EndProcedure
  Procedure.l Print_GetPreviewImage(Index.l)
    ProcedureReturn ipprint_GetPreviewImage(Index)
  EndProcedure
  Procedure.l Print_GetPrinterHandle()
    ProcedureReturn PrintLib_PH
  EndProcedure
  Procedure.l Print_GetStatus(Type.l)
    ProcedureReturn ipprint_GetStatus(Type)
  EndProcedure
  Procedure.l Print_GetTextAlign()
    ProcedureReturn ipprint_GetTextAlign()
  EndProcedure
  Procedure.f Print_GetTextMetrics(Type.l)
    ProcedureReturn ipprint_GetTextMetrics(Type)
  EndProcedure
  Procedure.l Print_GetUnits()
    ProcedureReturn ipprint_GetUnits()
  EndProcedure
  Procedure.f Print_GetX()
    ProcedureReturn ipprint_GetX()
  EndProcedure
  Procedure.f Print_GetY()
    ProcedureReturn ipprint_GetY()
  EndProcedure
  Procedure.l Print_GradientFill(*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
    ProcedureReturn ipprint_GradientFill(*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
  EndProcedure
  Procedure.l Print_Image(Imagenr.l,x.f,y.f,w.f=0,h.f=0,Mode=#SRCCOPY)
    ProcedureReturn ipprint_Image(Imagenr,x.f,y.f,w,h,#SRCCOPY)
  EndProcedure
  Procedure Print_Init()
    ipprint_Init()
  EndProcedure
  Procedure.l Print_InvertRect(x1.f,y1.f,x2.f,y2.f)
    ProcedureReturn Print_InvertRect(x1,y1,x2,y2)
  EndProcedure
  Procedure.l Print_Line(x.f,y.f,w.f,h.f)
    ProcedureReturn ipprint_Line(x,y,x+w,y+h)
  EndProcedure
  Procedure.l Print_LineTo(x.f,y.f)
    ProcedureReturn ipprint_LineTo(x,y)
  EndProcedure
  Procedure.l Print_LoadDEVMODE(Filename$)
    ProcedureReturn ipprint_LoadDEVMODE(Filename$)
  EndProcedure
  Procedure.l Print_NewPage()
    ProcedureReturn ipprint_NewPage()
  EndProcedure
  Procedure.l Print_OpenPrinter(Printername$="",Option$="",Access.l=0)
    ProcedureReturn ipprint_OpenPrinter(Printername$,Option$,Access)
  EndProcedure
  Procedure.l Print_Pie(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l=#False)
    ProcedureReturn ipprint_Pie(x1,y1,x2,y2,x3,y3,x4,y4,Fill)
  EndProcedure
  Procedure.l Print_Plot(x.f,y.f)
    ProcedureReturn ipprint_Plot(x,y)
  EndProcedure
  Procedure.l Print_PrintDlg(Window.i=0,Printername$="",Option1$="",Option2$="")
    ProcedureReturn ipprint_PrintDlg(Window,Printername$,Option1$,Option2$)
  EndProcedure
  Procedure.l Print_PrintPrefs(Window.i=0,PrinterName$="")
    ProcedureReturn ipprint_PrintPrefs(Window,PrinterName$)
  EndProcedure
  Procedure.l Print_Properties(Window.i=0)
    ProcedureReturn ipprint_Properties(Window.i)
  EndProcedure
  Procedure.l Print_Rectangle(x.f,y.f,w.f,h.f,Fill.l=#False)
    ProcedureReturn ipprint_Rectangle(x,y,x+w,y+h,Fill)
  EndProcedure
  Procedure.l Print_ResetDC(Option$)
    ProcedureReturn ipprint_ResetDC(Option$)
  EndProcedure
  Procedure.l Print_RoundRect(x1,y1,x2,y2,w,h,Fill=#False)
    ProcedureReturn ipprint_RoundRect(x1,y1,x2,y2,w,h,Fill)
  EndProcedure
  Procedure.l Print_SaveDEVMODE(Filename$)
    ProcedureReturn ipprint_SaveDEVMODE(Filename$)
  EndProcedure
  Procedure.l Print_SetArcDirection(arcd.l)
    ProcedureReturn ipprint_SetArcDirection(arcd.l)
  EndProcedure
  Procedure.l Print_SetBkColor(Color.l)
    ProcedureReturn ipprint_SetBkColor(Color.l)
  EndProcedure
  Procedure.l Print_SetBkMode(Mode.l)
    ProcedureReturn ipprint_SetBkMode(Mode.l)
  EndProcedure
  Procedure Print_SetDebug(Mode.l)
    ipprint_SetDebug(Mode)
  EndProcedure
  Procedure Print_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
    ipprint_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
  EndProcedure
  Procedure.l Print_SetLineColor(Color.l)
    ProcedureReturn ipprint_SetLineColor(Color.l)
  EndProcedure
  Procedure.l Print_SetLineStyle(Style.l)
    ProcedureReturn ipprint_SetLineStyle(Style.l)
  EndProcedure
  Procedure.l Print_SetLineWidth(w.f)
    ProcedureReturn ipprint_SetLineWidth(w)
  EndProcedure
  Procedure.l Print_SetPRINTDLG(Option$,*PrinterParameters.PRINTDLG)
    ProcedureReturn ipprint_SetPRINTDLG(Option$,*PrinterParameters.PRINTDLG)
  EndProcedure
  Procedure Print_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
    ipprint_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
  EndProcedure
  Procedure.l Print_SetStatus(Status.l)
    ProcedureReturn ipprint_SetStatus(Status)
  EndProcedure
  Procedure.l Print_SetTextAlign(Mode.l)
    ProcedureReturn ipprint_SetTextAlign(Mode.l)
  EndProcedure
  Procedure.l Print_SetTextColor(Color.l)
    ProcedureReturn SetTextColor_(PrintLib_DC,Color)
  EndProcedure
  Procedure.l Print_SetTextJustification(l.f,Count.l)
    ProcedureReturn ipprint_SetTextJustification(l,Count)
  EndProcedure
  Procedure.f Print_SetTextSpacing(l.f)
    ProcedureReturn ipprint_SetTextSpacing(l)
  EndProcedure
  Procedure.l Print_SetUnits(Unit.l)
    ProcedureReturn ipprint_SetUnits(Unit.l)
  EndProcedure
  Procedure.l Print_SetX(x.f)
    ProcedureReturn Print_SetX(x)
  EndProcedure
  Procedure.l Print_SetXY(x.f,y.f)
    ProcedureReturn ipprint_SetXY(x,y)
  EndProcedure
  Procedure.l Print_SetY(y.f)
    ProcedureReturn ipprint_SetY(y.f)
  EndProcedure
  Procedure.l Print_StartDoc(Jobname$,OutputFileName$="",Datatype$="RAW")
    ProcedureReturn ipprint_StartDocPrinter(Jobname$,OutputFileName$,Datatype$)
  EndProcedure
  Procedure.l Print_StartPreview(x.l)
    ProcedureReturn ipprint_StartPreview(x)
  EndProcedure
  Procedure.l Print_StartPrinting(Jobname$,Outfile$="")
    ProcedureReturn ipprint_StartPrinting(Jobname$,Outfile$)
  EndProcedure
  Procedure.l Print_StopPreview()
    ProcedureReturn ipprint_StopPreview()
  EndProcedure
  Procedure.l Print_StopPrinting()
    ProcedureReturn ipprint_StopPrinting()
  EndProcedure
  Procedure.l Print_Text(x.f,y.f,Text$)
    ProcedureReturn ipprint_Text(x.f,y.f,Text$)
  EndProcedure
  Procedure.f Print_TextHeight(Text$)
    ProcedureReturn ipprint_TextHeight(Text$)
  EndProcedure
  Procedure.f Print_TextWidth(Text$)
    ProcedureReturn ipprint_TextWidth(Text$)
  EndProcedure
  Procedure.l Print_WriteData(*Membuffer,Size.l)
    ProcedureReturn ipprint_WriteData(*Membuffer,Size.l)
  EndProcedure
  Procedure.l Print_WriteString(String$,Mode=#PB_Ascii)
    ProcedureReturn ipprint_WriteString(String$,Mode)
  EndProcedure
  Procedure.l Print_WriteStringN(String$,Mode=#PB_Ascii)
    ProcedureReturn ipprint_WriteString(String$+#CRLF$,Mode)
  EndProcedure
  Procedure.s Print_EnumFontName(Index.l)
    ProcedureReturn ipprint_EnumFontName(Index.l)
  EndProcedure
  Procedure.s Print_EnumFontScript(Index.l)
    ProcedureReturn ipprint_EnumFontScript(Index)
  EndProcedure
  Procedure.s Print_EnumFontStyle(Index.l)
    ProcedureReturn ipprint_EnumFontStyle(Index)
  EndProcedure
  Procedure.s Print_EnumPrinterName(Index.l)
    ProcedureReturn ipprint_EnumPrinterName(Index)
  EndProcedure
  Procedure.s Print_GetDefaultPrinter()
    ProcedureReturn ipprint_GetDefaultPrinter()
  EndProcedure
  Procedure.s Print_GetDeviceCapabilities(Type.l,Separator$="|")
    ProcedureReturn ipprint_GetDeviceCapabilities(Type,Separator$)
  EndProcedure
  Procedure.s Print_GetFontName()
    ProcedureReturn PrintLib_FontName$
  EndProcedure
  Procedure.s Print_GetLastError(err.l=0)
    ProcedureReturn ipprint_GetLastError(err)
  EndProcedure
  Procedure.s Print_GetPrinterName()
    ProcedureReturn PrintLib_PN
  EndProcedure
  Procedure.l Print_GetPrintDlg()
    ProcedureReturn ipprint_GetPrintDlg()
  EndProcedure
  ;}
CompilerElse;{ include as Library
  
  ProcedureDLL Print_About()
    MessageRequester("Printer_Lib","Written by Klaus Dresen",0)
  EndProcedure
  ProcedureDLL.l Print_AdvancedProperties(Window.i)
    ProcedureReturn ipprint_AdvancedProperties(Window.i)
  EndProcedure
  ProcedureDLL.l Print_AngleArc(x.f,y.f,r.f,Startangle.l,Sweepangle.l)
    ProcedureReturn ipprint_AngleArc(x,y,r,Startangle,Sweepangle)
  EndProcedure
  ProcedureDLL.l Print_Arc(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f)
    ProcedureReturn ipprint_Arc(x1,y1,x2,y2,x3,y3,x4,y4)
  EndProcedure
  ProcedureDLL.l Print_Box(x.f,y.f,w.f,h.f)
    ProcedureReturn ipprint_Rectangle(x,y,x+w,y+h,#False)
  EndProcedure
  ProcedureDLL.l Print_Box2(x.f,y.f,w.f,h.f,Fill.l)
    ProcedureReturn ipprint_Rectangle(x,y,x+w,y+h,Fill)
  EndProcedure
  ProcedureDLL.l Print_Chord(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l)
    ProcedureReturn ipprint_Chord(x1,y1,x2,y2,x3,y3,x4,y4,Fill)
  EndProcedure
  ProcedureDLL.l Print_Circle(x.f,y.f,r.f,Fill.l)
    ProcedureReturn ipprint_Ellipse(x-r,y-r,x+r,y+r,Fill)
  EndProcedure
  ProcedureDLL.l Print_ConvertUnitsToPointsX(x.f)
    ProcedureReturn ipprint_ConvertUnitsToPointsX(x.f)
  EndProcedure
  ProcedureDLL.l Print_ConvertUnitsToPointsY(y.f)
    ProcedureReturn ipprint_ConvertUnitsToPointsY(y.f)
  EndProcedure
  ProcedureDLL.f Print_ConvertPointsToUnitsX(x.l)
    ProcedureReturn ipprint_ConvertPointsToUnitsX(x.l)
  EndProcedure
  ProcedureDLL.f Print_ConvertPointsToUnitsY(y.l)
    ProcedureReturn ipprint_ConvertPointsToUnitsY(y.l)
  EndProcedure
  ProcedureDLL.l Print_CountFonts()
    ProcedureReturn ListSize(Print_Fonts())
  EndProcedure
  ProcedureDLL.l Print_CountPrinters()
    ProcedureReturn ListSize(Print_Printers())
  EndProcedure
  ProcedureDLL.l Print_CreateBrush(Color.l)
    ProcedureReturn ipprint_CreateBrush(Color)
  EndProcedure
  ProcedureDLL.l Print_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
    ProcedureReturn ipprint_CreateBrushIndirect(Style.l,Color.l,Hatch.l)
  EndProcedure
  ProcedureDLL.l Print_CreateHatchBrush(Style.l,Color.l)
    ProcedureReturn ipprint_CreateHatchBrush(Style.l,Color.l)
  EndProcedure
  ProcedureDLL.l Print_CreatePatternBrush(hBMP.l)
    ProcedureReturn ipprint_CreatePatternBrush(hBMP.l)
  EndProcedure
  ProcedureDLL.l Print_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style)
    ProcedureReturn ipprint_CreatePen(Style.l,w.f,Color.l,Stylecount.l,*Style)
  EndProcedure
  ProcedureDLL.f Print_DrawText(x.f,y.f,w.f,h.f,Text$)
    ProcedureReturn ipprint_DrawText(x.f,y.f,w.f,h.f,Text$,0,0,0,0,0)
  EndProcedure
  ProcedureDLL.f Print_DrawText2(x.f,y.f,w.f,h.f,Text$,Format.l)
    ProcedureReturn ipprint_DrawText(x.f,y.f,w.f,h.f,Text$,Format,0,0,0,0)
  EndProcedure
  ProcedureDLL.f Print_DrawText3(x.f,y.f,w.f,h.f,Text$,Format.l,*RX,*RY,*RW,*RH)
    ProcedureReturn ipprint_DrawText(x.f,y.f,w.f,h.f,Text$,Format,*RX,*RY,*RW,*RH)
  EndProcedure
  ProcedureDLL.l Print_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l)
    ProcedureReturn ipprint_Ellipse(x1.f,y1.f,x2.f,y2.f,Fill.l)
  EndProcedure
  ProcedureDLL Print_End()
    ipprint_End()
  EndProcedure
  ProcedureDLL.l Print_EndDocPrinter()
    ProcedureReturn ipprint_EndDocPrinter()
  EndProcedure
  ProcedureDLL.l Print_EndPagePrinter()
    ProcedureReturn EndPagePrinter_(PrintLib_PH)
  EndProcedure
  ProcedureDLL.l Print_EnumFontID(Index.l)
    ProcedureReturn ipprint_EnumFontID(Index)
  EndProcedure
  ProcedureDLL.l Print_EnumFonts()
    ProcedureReturn ipprint_EnumFonts(#DEFAULT_CHARSET,0,"")
  EndProcedure
  ProcedureDLL.l Print_EnumFonts2(CharSet.b)
    ProcedureReturn ipprint_EnumFonts(CharSet,0,"")
  EndProcedure
  ProcedureDLL.l Print_EnumFonts3(CharSet.b,Name.s)
    ProcedureReturn ipprint_EnumFonts(CharSet,0,Name)
  EndProcedure
  ProcedureDLL.l Print_EnumPrinters()
    ProcedureReturn ipprint_EnumPrinters()
  EndProcedure
  ProcedureDLL.l Print_EnumPrinters2(enum.l)
    ProcedureReturn ipprint_EnumPrinters(enum)
  EndProcedure
  ProcedureDLL.l Print_FillRect(x1.f,y1.f,x2.f,y2.f)
    ProcedureReturn ipprint_FillRect(x1,y1,x2,y2)
  EndProcedure
  ProcedureDLL.l Print_Font(Font$,Height.l)
    ProcedureReturn ipprint_Font(Font$,Height)
  EndProcedure
  ProcedureDLL.l Print_Font2(Font$,Height.l,Flags.l)
    ProcedureReturn ipprint_Font(Font$,Height,Flags)
  EndProcedure
  ProcedureDLL.l Print_Font3(Font$,Height.l,Flags.l,Rotate.l)
    ProcedureReturn ipprint_Font(Font$,Height,Flags,Rotate)
  EndProcedure
  ProcedureDLL.l Print_FrameRect(x1.f,y1.f,x2.f,y2.f)
    ProcedureReturn ipprint_FrameRect(x1,y1,x2,y2)
  EndProcedure
  ProcedureDLL.l Print_GetArcDirection()
    ProcedureReturn ipprint_GetArcDirection()
  EndProcedure
  ProcedureDLL.l Print_GetDeviceCaps(Type.l)
    ProcedureReturn ipprint_GetDeviceCaps(Type.l)
  EndProcedure
  ProcedureDLL.l Print_GetFontFlags()
    ProcedureReturn PrintLib_FontFlags
  EndProcedure
  ProcedureDLL.l Print_GetFontHeight()
    ProcedureReturn PrintLib_FontHeight
  EndProcedure
  ProcedureDLL.l Print_GetFontRotate()
    ProcedureReturn PrintLib_FontRotate
  EndProcedure
  ProcedureDLL.l Print_GetLineColor()
    ProcedureReturn ipprint_GetLineColor()
  EndProcedure
  ProcedureDLL.l Print_GetLineStyle()
    ProcedureReturn ipprint_GetLineStyle()
  EndProcedure
  ProcedureDLL.f Print_GetLineWidth()
    ProcedureReturn ipprint_GetLineWidth()
  EndProcedure
  ProcedureDLL.f Print_GetOutlineTextMetrics(Type.l)
    ProcedureReturn ipprint_GetOutlineTextMetrics(Type.l)
  EndProcedure
  ProcedureDLL.l Print_GetPreviewCount()
    ProcedureReturn ListSize(PrintLib_Images())
  EndProcedure
  ProcedureDLL.l Print_GetPreviewImage(Index.l)
    ProcedureReturn ipprint_GetPreviewImage(Index)
  EndProcedure
  ProcedureDLL.l Print_GetPrinterHandle()
    ProcedureReturn PrintLib_PH
  EndProcedure
  ProcedureDLL.l Print_GetStatus(Type.l)
    ProcedureReturn ipprint_GetStatus(Type)
  EndProcedure
  ProcedureDLL.l Print_GetTextAlign()
    ProcedureReturn ipprint_GetTextAlign()
  EndProcedure
  ProcedureDLL.f Print_GetTextMetrics(Type.l)
    ProcedureReturn ipprint_GetTextMetrics(Type)
  EndProcedure
  ProcedureDLL.l Print_GetUnits()
    ProcedureReturn ipprint_GetUnits()
  EndProcedure
  ProcedureDLL.f Print_GetX()
    ProcedureReturn ipprint_GetX()
  EndProcedure
  ProcedureDLL.f Print_GetY()
    ProcedureReturn ipprint_GetY()
  EndProcedure
  ProcedureDLL.l Print_GradientFill(*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
    ProcedureReturn ipprint_GradientFill(*Vertex,NumVertex.l,*Mesh,NumMesh.l,Mode.l)
  EndProcedure
  ProcedureDLL.l Print_Image(Imagenr.l,x.f,y.f)
    ProcedureReturn ipprint_Image(Imagenr,x.f,y.f)
  EndProcedure
  ProcedureDLL.l Print_Image2(Imagenr.l,x.f,y.f,w.f,h.f)
    ProcedureReturn ipprint_Image(Imagenr,x.f,y.f,w,h)
  EndProcedure
  ProcedureDLL.l Print_Image3(Imagenr.l,x.f,y.f,w.f,h.f,Mode)
    ProcedureReturn ipprint_Image(Imagenr,x.f,y.f,w,h,Mode)
  EndProcedure
  ProcedureDLL Print_Init()
    ipprint_Init()
  EndProcedure
  ProcedureDLL.l Print_InvertRect(x1.f,y1.f,x2.f,y2.f)
    ProcedureReturn Print_InvertRect(x1,y1,x2,y2)
  EndProcedure
  ProcedureDLL.l Print_Line(x.f,y.f,w.f,h.f)
    ProcedureReturn ipprint_Line(x,y,x+w,y+h)
  EndProcedure
  ProcedureDLL.l Print_LineTo(x.f,y.f)
    ProcedureReturn ipprint_LineTo(x,y)
  EndProcedure
  ProcedureDLL.l Print_LoadDEVMODE(Filename$)
    ProcedureReturn ipprint_LoadDEVMODE(Filename$)
  EndProcedure
  ProcedureDLL.l Print_NewPage()
    ProcedureReturn ipprint_NewPage()
  EndProcedure
  ProcedureDLL.l Print_OpenPrinter()
    ProcedureReturn ipprint_OpenPrinter()
  EndProcedure
  ProcedureDLL.l Print_OpenPrinter2(Printername$)
    ProcedureReturn ipprint_OpenPrinter(Printername$)
  EndProcedure
  ProcedureDLL.l Print_OpenPrinter3(Printername$,Option$)
    ProcedureReturn ipprint_OpenPrinter(Printername$,Option$)
  EndProcedure
  ProcedureDLL.l Print_OpenPrinter4(Printername$,Option$,Access.l)
    ProcedureReturn ipprint_OpenPrinter(Printername$,Option$,Access)
  EndProcedure
  ProcedureDLL.l Print_Pie(x1.f,y1.f,x2.f,y2.f,x3.f,y3.f,x4.f,y4.f,Fill.l)
    ProcedureReturn ipprint_Pie(x1,y1,x2,y2,x3,y3,x4,y4,Fill)
  EndProcedure
  ProcedureDLL.l Print_Plot(x.f,y.f)
    ProcedureReturn ipprint_Plot(x,y)
  EndProcedure
  ProcedureDLL.l Print_PrintDlg()
    ProcedureReturn ipprint_PrintDlg()
  EndProcedure
  ProcedureDLL.l Print_PrintDlg2(Window.i)
    ProcedureReturn ipprint_PrintDlg(Window)
  EndProcedure
  ProcedureDLL.l Print_PrintDlg3(Window.i,Printername$)
    ProcedureReturn ipprint_PrintDlg(Window,Printername$)
  EndProcedure
  ProcedureDLL.l Print_PrintDlg4(Window.i,Printername$,Option$)
    ProcedureReturn ipprint_PrintDlg(Window,Printername$,Option$)
  EndProcedure
  ProcedureDLL.l Print_PrintDlg5(Window.i,Printername$,Option1$,Option2$)
    ProcedureReturn ipprint_PrintDlg(Window,Printername$,Option1$,Option2$)
  EndProcedure
  ProcedureDLL.l Print_PrintPrefs()
    ProcedureReturn ipprint_PrintPrefs(0,"")
  EndProcedure
  ProcedureDLL.l Print_PrintPrefs2(Window.i)
    ProcedureReturn ipprint_PrintPrefs(Window,"")
  EndProcedure
  ProcedureDLL.l Print_PrintPrefs3(Window.i,PrinterName$)
    ProcedureReturn ipprint_PrintPrefs(Window,PrinterName$)
  EndProcedure
  ProcedureDLL.l Print_Properties()
    ProcedureReturn ipprint_Properties()
  EndProcedure
  ProcedureDLL.l Print_Properties2(Window.i)
    ProcedureReturn ipprint_Properties(Window.i)
  EndProcedure
  ProcedureDLL.l Print_Rectangle(x.f,y.f,w.f,h.f)
    ProcedureReturn ipprint_Rectangle(x,y,x+w,y+h,#False)
  EndProcedure
  ProcedureDLL.l Print_Rectangle2(x.f,y.f,w.f,h.f,Fill.l)
    ProcedureReturn ipprint_Rectangle(x,y,x+w,y+h,Fill)
  EndProcedure
  ProcedureDLL.l Print_ResetDC(Option$)
    ProcedureReturn ipprint_ResetDC(Option$)
  EndProcedure
  ProcedureDLL.l Print_RoundRect(x1,y1,x2,y2,w,h)
    ProcedureReturn ipprint_RoundRect(x1,y1,x2,y2,w,h,#False)
  EndProcedure
  ProcedureDLL.l Print_RoundRect2(x1,y1,x2,y2,w,h,Fill)
    ProcedureReturn ipprint_RoundRect(x1,y1,x2,y2,w,h,Fill)
  EndProcedure
  ProcedureDLL.l Print_SaveDEVMODE(Filename$)
    ProcedureReturn ipprint_SaveDEVMODE(Filename$)
  EndProcedure
  ProcedureDLL.l Print_SetArcDirection(arcd.l)
    ProcedureReturn ipprint_SetArcDirection(arcd.l)
  EndProcedure
  ProcedureDLL.l Print_SetBkColor(Color.l)
    ProcedureReturn ipprint_SetBkColor(Color.l)
  EndProcedure
  ProcedureDLL.l Print_SetBkMode(Mode.l)
    ProcedureReturn ipprint_SetBkMode(Mode.l)
  EndProcedure
  ProcedureDLL Print_SetDebug(Mode.l)
    ipprint_SetDebug(Mode)
  EndProcedure
  ProcedureDLL Print_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
    ipprint_SetDEVMODE(Option$,*PrinterParameters.DEVMODE)
  EndProcedure
  ProcedureDLL.l Print_SetLineColor(Color.l)
    ProcedureReturn ipprint_SetLineColor(Color.l)
  EndProcedure
  ProcedureDLL.l Print_SetLineStyle(Style.l)
    ProcedureReturn ipprint_SetLineStyle(Style.l)
  EndProcedure
  ProcedureDLL.l Print_SetLineWidth(w.f)
    ProcedureReturn ipprint_SetLineWidth(w)
  EndProcedure
  ProcedureDLL.l Print_SetPRINTDLG(Option$,*PrinterParameters.PRINTDLG)
    ProcedureReturn ipprint_SetPRINTDLG(Option$,*PrinterParameters.PRINTDLG)
  EndProcedure
  ProcedureDLL Print_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
    ipprint_SetPRINTDLGEX(Option$,*PrinterParameters.PRINTDLGEX)
  EndProcedure
  ProcedureDLL.l Print_SetStatus(Status.l)
    ProcedureReturn ipprint_SetStatus(Status)
  EndProcedure
  ProcedureDLL.l Print_SetTextAlign(Mode.l)
    ProcedureReturn ipprint_SetTextAlign(Mode.l)
  EndProcedure
  ProcedureDLL.l Print_SetTextColor(Color.l)
    ProcedureReturn SetTextColor_(PrintLib_DC,Color)
  EndProcedure
  ProcedureDLL.l Print_SetTextJustification(l.f,Count.l)
    ProcedureReturn ipprint_SetTextJustification(l,Count)
  EndProcedure
  ProcedureDLL.f Print_SetTextSpacing(l.f)
    ProcedureReturn ipprint_SetTextSpacing(l)
  EndProcedure
  ProcedureDLL.l Print_SetUnits(Unit.l)
    ProcedureReturn ipprint_SetUnits(Unit.l)
  EndProcedure
  ProcedureDLL.l Print_SetX(x.f)
    ProcedureReturn Print_SetX(x)
  EndProcedure
  ProcedureDLL.l Print_SetXY(x.f,y.f)
    ProcedureReturn ipprint_SetXY(x,y)
  EndProcedure
  ProcedureDLL.l Print_SetY(y.f)
    ProcedureReturn ipprint_SetY(y.f)
  EndProcedure
  ProcedureDLL.l Print_StartDoc(Jobname$)
    ProcedureReturn ipprint_StartDocPrinter(Jobname$)
  EndProcedure
  ProcedureDLL.l Print_StartDoc2(Jobname$,OutputFileName$)
    ProcedureReturn ipprint_StartDocPrinter(Jobname$,OutputFileName$)
  EndProcedure
  ProcedureDLL.l Print_StartDoc3(Jobname$,OutputFileName$,Datatype$)
    ProcedureReturn ipprint_StartDocPrinter(Jobname$,OutputFileName$,Datatype$)
  EndProcedure
  ProcedureDLL.l Print_StartPreview(x.l)
    ProcedureReturn ipprint_StartPreview(x)
  EndProcedure
  ProcedureDLL.l Print_StartPrinting(Jobname$)
    ProcedureReturn ipprint_StartPrinting(Jobname$,"")
  EndProcedure
  ProcedureDLL.l Print_StartPrinting2(Jobname$,Outfile$)
    ProcedureReturn ipprint_StartPrinting(Jobname$,Outfile$)
  EndProcedure
  ProcedureDLL.l Print_StopPreview()
    ProcedureReturn ipprint_StopPreview()
  EndProcedure
  ProcedureDLL.l Print_StopPrinting()
    ProcedureReturn ipprint_StopPrinting()
  EndProcedure
  ProcedureDLL.l Print_Text(x.f,y.f,Text$)
    ProcedureReturn ipprint_Text(x.f,y.f,Text$)
  EndProcedure
  ProcedureDLL.f Print_TextHeight(Text$)
    ProcedureReturn ipprint_TextHeight(Text$)
  EndProcedure
  ProcedureDLL.f Print_TextWidth(Text$)
    ProcedureReturn ipprint_TextWidth(Text$)
  EndProcedure
  ProcedureDLL.l Print_WriteData(*Membuffer,Size.l)
    ProcedureReturn ipprint_WriteData(*Membuffer,Size.l)
  EndProcedure
  ProcedureDLL.l Print_WriteString(String$)
    ProcedureReturn ipprint_WriteString(String$)
  EndProcedure
  ProcedureDLL.l Print_WriteString2(String$,Mode)
    ProcedureReturn ipprint_WriteString(String$,Mode)
  EndProcedure
  ProcedureDLL.l Print_WriteStringN(String$)
    ProcedureReturn ipprint_WriteString(String$+#CRLF$)
  EndProcedure
  ProcedureDLL.l Print_WriteStringN2(String$,Mode)
    ProcedureReturn ipprint_WriteString(String$+#CRLF$,Mode)
  EndProcedure
  ProcedureDLL.s Print_EnumFontName(Index.l)
    ProcedureReturn ipprint_EnumFontName(Index.l)
  EndProcedure
  ProcedureDLL.s Print_EnumFontScript(Index.l)
    ProcedureReturn ipprint_EnumFontScript(Index)
  EndProcedure
  ProcedureDLL.s Print_EnumFontStyle(Index.l)
    ProcedureReturn ipprint_EnumFontStyle(Index)
  EndProcedure
  ProcedureDLL.s Print_EnumPrinterName(Index.l)
    ProcedureReturn ipprint_EnumPrinterName(Index)
  EndProcedure
  ProcedureDLL.s Print_GetDefaultPrinter()
    ProcedureReturn ipprint_GetDefaultPrinter()
  EndProcedure
  ProcedureDLL.s Print_GetDeviceCapabilities(Type.l)
    ProcedureReturn ipprint_GetDeviceCapabilities(Type)
  EndProcedure
  ProcedureDLL.s Print_GetDeviceCapabilities2(Type.l,Separator$)
    ProcedureReturn ipprint_GetDeviceCapabilities(Type,Separator$)
  EndProcedure
  ProcedureDLL.s Print_GetFontName()
    ProcedureReturn PrintLib_FontName$
  EndProcedure
  ProcedureDLL.s Print_GetLastError()
    ProcedureReturn ipprint_GetLastError()
  EndProcedure
  ProcedureDLL.s Print_GetLastError2(Err.l)
    ProcedureReturn ipprint_GetLastError(Err)
  EndProcedure
  ProcedureDLL.s Print_GetPrinterName()
    ProcedureReturn PrintLib_PN
  EndProcedure
  ProcedureDLL.l Print_GetPrintDlg()
    ProcedureReturn ipprint_GetPrintDlg()
  EndProcedure
CompilerEndIf;}

; IDE Options = PureBasic 5.10 (Windows - x86)
; CursorPosition = 1492
; FirstLine = 1466
; Folding = ----------------------------------------------------------
; DisableDebugger